using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using ppsGrid;

namespace grdDemo.frm{
	/// <summary>
	/// Summary description for frmCtrlCheckbox.
	/// </summary>
	public class frmCtrlCheckbox : System.Windows.Forms.Form
	{
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.Label label2;
		private System.Windows.Forms.Label label3;
		private ppsGrid.GridRow rowDispFixed;
		private ppsGrid.GridRow rowEditFixed;
		private ppsGrid.GridRow rowDispEditFixed;
		private ppsGrid.GridCol colDispEditNo;
		private ppsGrid.GridCol colEditNo;
		private ppsGrid.GridCol colDispNo;
		private ppsGrid.GridCol colDispCheck;
		private ppsGrid.GridCol colEditCheck;
		private ppsGrid.GridCol colDispEditCheck;
		private ppsGrid.Grid grdDisp;
		private ppsGrid.Grid grdEdit;
		private ppsGrid.Grid grdDispEdit;
		private System.Windows.Forms.ComboBox colCombo;
		private ppsGrid.GridRow gridRow1;
		private System.Windows.Forms.CheckBox chkDisplay;
		private System.Windows.Forms.CheckBox chkEdit;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public frmCtrlCheckbox(){
			InitializeComponent();
		}
		public void Init(){
			CheckBox	chk;
			Random		rnd=new Random();

			chk=new CheckBox();
			chk.Dock=DockStyle.Fill;
			chk.Text="...";
			chk.CheckAlign=ContentAlignment.MiddleCenter;
			grdDisp.AddRows(20);
			grdDisp.Cols["colDispCheck"].ControlDisplayInfo.Control=chk;
			grdDisp.Cols["colDispCheck"].ControlDisplayInfo.PropertyName="Checked";
			foreach(GridRow r in grdDisp.Rows)
				if(r.Fixed==false)
					r["colDispCheck"].Value=(rnd.Next(2)==0?false:true);

		



			chk=new CheckBox();
			chk.Dock=DockStyle.Fill;
			chk.Text="...";
			grdEdit.AddRows(20);
			grdEdit.Cols["colEditCheck"].ControlEditInfo.Control=chk;
			grdEdit.Cols["colEditCheck"].ControlEditInfo.PropertyName="Checked";
			foreach(GridRow r in grdEdit.Rows)
				if(r.Fixed==false)
					r["colEditCheck"].Value=(rnd.Next(2)==0?false:true);

		



		
//			chk=new CheckBox();
//			chk.Dock=DockStyle.Fill;
//			chk.Text="...";
			grdDispEdit.AddRows(20);
			grdDispEdit.ControlEditInfo.KeyEditBegin.Modifier=Keys.Shift;
			grdDispEdit.ControlEditInfo.KeyEditBegin.Key=Keys.F3;
			grdDispEdit.ControlEditInfo.KeyEditEnd.Modifier=(Keys.Shift|Keys.Alt);
			grdDispEdit.ControlEditInfo.KeyEditEnd.Key=Keys.Q;
			grdDispEdit.ControlEditInfo.KeyEditCancel.Modifier=(Keys.Control);
			grdDispEdit.ControlEditInfo.KeyEditCancel.Key=Keys.F12;

			
//		grdDispEdit.Cols["colDispEditCheck"].ControlDisplayInfo.Control=chk;
//		grdDispEdit.Cols["colDispEditCheck"].ControlDisplayInfo.PropertyName="Checked";

//			chk=new CheckBox();
//			chk.Dock=DockStyle.Fill;
//			chk.Text="...";
//			grdDispEdit.Cols["colDispEditCheck"].ControlEditInfo.Control=chk;
//			grdDispEdit.Cols["colDispEditCheck"].ControlEditInfo.PropertyName="Checked";
			foreach(GridRow r in grdDispEdit.Rows)
				if(r.Fixed==false)
					r["colDispEditCheck"].Value=Enum.GetValues(typeof(CheckState)).GetValue(rnd.Next(3));
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(frmCtrlCheckbox));
			this.grdDisp = new ppsGrid.Grid();
			this.rowDispFixed = new ppsGrid.GridRow();
			this.colDispNo = new ppsGrid.GridCol();
			this.colDispCheck = new ppsGrid.GridCol();
			this.grdEdit = new ppsGrid.Grid();
			this.rowEditFixed = new ppsGrid.GridRow();
			this.colEditNo = new ppsGrid.GridCol();
			this.colEditCheck = new ppsGrid.GridCol();
			this.label1 = new System.Windows.Forms.Label();
			this.label2 = new System.Windows.Forms.Label();
			this.label3 = new System.Windows.Forms.Label();
			this.grdDispEdit = new ppsGrid.Grid();
			this.gridRow1 = new ppsGrid.GridRow();
			this.chkDisplay = new System.Windows.Forms.CheckBox();
			this.colDispEditNo = new ppsGrid.GridCol();
			this.colDispEditCheck = new ppsGrid.GridCol();
			this.chkEdit = new System.Windows.Forms.CheckBox();
			this.rowDispEditFixed = new ppsGrid.GridRow();
			this.colCombo = new System.Windows.Forms.ComboBox();
			this.SuspendLayout();
			// 
			// grdDisp
			// 
			this.grdDisp.Anchor = ((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Left);
			this.grdDisp.BottomRow = this.rowDispFixed;
			this.grdDisp.Cols.AddRange(new object[] {
																								this.colDispNo,
																								this.colDispCheck});
			this.grdDisp.ControlEditInfo.Control = null;
			this.grdDisp.FixedRowType = (ppsGrid.eFixedRowType.Moveable | ppsGrid.eFixedRowType.Sizeable);
			this.grdDisp.LeftCol = this.colDispCheck;
			this.grdDisp.Location = new System.Drawing.Point(16, 24);
			this.grdDisp.Name = "grdDisp";
			this.grdDisp.PreferredRowHeight = 24;
			this.grdDisp.RightCol = this.colDispCheck;
			this.grdDisp.Rows.AddRange(new object[] {
																								this.rowDispFixed});
			this.grdDisp.SelectionType = ppsGrid.eSelectionType.None;
			this.grdDisp.Size = new System.Drawing.Size(80, 288);
			this.grdDisp.TabIndex = 0;
			this.grdDisp.TopRow = this.rowDispFixed;
			// 
			// rowDispFixed
			// 
			this.rowDispFixed.Fixed = true;
			this.rowDispFixed.Name = "rowDispFixed";
			// 
			// colDispNo
			// 
			this.colDispNo.AutoNumber = true;
			this.colDispNo.Fixed = true;
			this.colDispNo.Name = "colDispNo";
			this.colDispNo.Width = 25;
			this.colDispNo.WidthPercent = 35;
			// 
			// colDispCheck
			// 
			this.colDispCheck.Name = "colDispCheck";
			this.colDispCheck.WidthPercent = 100;
			this.colDispCheck.WidthType = ppsGrid.eWidthType.Percent;
			// 
			// grdEdit
			// 
			this.grdEdit.Anchor = ((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Left);
			this.grdEdit.BottomRow = this.rowEditFixed;
			this.grdEdit.Cols.AddRange(new object[] {
																								this.colEditNo,
																								this.colEditCheck});
			this.grdEdit.ControlEditInfo.Control = null;
			this.grdEdit.FixedRowType = (ppsGrid.eFixedRowType.Moveable | ppsGrid.eFixedRowType.Sizeable);
			this.grdEdit.LeftCol = this.colEditCheck;
			this.grdEdit.Location = new System.Drawing.Point(104, 24);
			this.grdEdit.Name = "grdEdit";
			this.grdEdit.RightCol = this.colEditCheck;
			this.grdEdit.Rows.AddRange(new object[] {
																								this.rowEditFixed});
			this.grdEdit.SelectionType = ppsGrid.eSelectionType.None;
			this.grdEdit.Size = new System.Drawing.Size(88, 288);
			this.grdEdit.TabIndex = 0;
			this.grdEdit.TopRow = this.rowEditFixed;
			// 
			// rowEditFixed
			// 
			this.rowEditFixed.Fixed = true;
			this.rowEditFixed.Name = "rowEditFixed";
			// 
			// colEditNo
			// 
			this.colEditNo.AutoNumber = true;
			this.colEditNo.Fixed = true;
			this.colEditNo.Name = "colEditNo";
			this.colEditNo.Width = 25;
			this.colEditNo.WidthPercent = 35;
			// 
			// colEditCheck
			// 
			this.colEditCheck.Name = "colEditCheck";
			this.colEditCheck.WidthPercent = 100;
			this.colEditCheck.WidthType = ppsGrid.eWidthType.Percent;
			// 
			// label1
			// 
			this.label1.Location = new System.Drawing.Point(16, 8);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(72, 16);
			this.label1.TabIndex = 1;
			this.label1.Text = "nur Anzeige";
			this.label1.TextAlign = System.Drawing.ContentAlignment.TopCenter;
			// 
			// label2
			// 
			this.label2.Location = new System.Drawing.Point(104, 8);
			this.label2.Name = "label2";
			this.label2.Size = new System.Drawing.Size(80, 16);
			this.label2.TabIndex = 2;
			this.label2.Text = "nur Editieren";
			this.label2.TextAlign = System.Drawing.ContentAlignment.TopCenter;
			// 
			// label3
			// 
			this.label3.Location = new System.Drawing.Point(208, 8);
			this.label3.Name = "label3";
			this.label3.Size = new System.Drawing.Size(192, 16);
			this.label3.TabIndex = 4;
			this.label3.Text = "Anzeige+Editieren";
			this.label3.TextAlign = System.Drawing.ContentAlignment.TopCenter;
			// 
			// grdDispEdit
			// 
			this.grdDispEdit.Anchor = (((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right);
			this.grdDispEdit.BottomRow = this.gridRow1;
			this.grdDispEdit.Cols.AddRange(new object[] {
																										this.colDispEditNo,
																										this.colDispEditCheck});
			this.grdDispEdit.ControlDisplayInfo.Control = this.chkDisplay;
			this.grdDispEdit.ControlDisplayInfo.PropertyName = "CheckState";
			this.grdDispEdit.ControlEditInfo.Control = this.chkEdit;
			this.grdDispEdit.ControlEditInfo.PropertyName = "CheckState";
			this.grdDispEdit.FixedRowType = (ppsGrid.eFixedRowType.Moveable | ppsGrid.eFixedRowType.Sizeable);
			this.grdDispEdit.LeftCol = this.colDispEditCheck;
			this.grdDispEdit.Location = new System.Drawing.Point(200, 24);
			this.grdDispEdit.Name = "grdDispEdit";
			this.grdDispEdit.PreferredRowHeight = 24;
			this.grdDispEdit.RightCol = this.colDispEditCheck;
			this.grdDispEdit.Rows.AddRange(new object[] {
																										this.rowDispEditFixed,
																										this.gridRow1});
			this.grdDispEdit.SelectionType = ppsGrid.eSelectionType.None;
			this.grdDispEdit.Size = new System.Drawing.Size(208, 288);
			this.grdDispEdit.TabIndex = 3;
			this.grdDispEdit.TopRow = this.gridRow1;
			// 
			// gridRow1
			// 
			this.gridRow1.Height = 24;
			this.gridRow1.Name = "gridRow1";
			// 
			// chkDisplay
			// 
			this.chkDisplay.BackColor = System.Drawing.Color.Yellow;
			this.chkDisplay.Name = "chkDisplay";
			this.chkDisplay.Size = new System.Drawing.Size(80, 24);
			this.chkDisplay.TabIndex = 6;
			this.chkDisplay.Text = "checkBox1";
			this.chkDisplay.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// colDispEditNo
			// 
			this.colDispEditNo.AutoNumber = true;
			this.colDispEditNo.BackColorCell = System.Drawing.Color.FromArgb(((System.Byte)(255)), ((System.Byte)(192)), ((System.Byte)(192)));
			this.colDispEditNo.BackColorCellGradient = System.Drawing.Color.FromArgb(((System.Byte)(255)), ((System.Byte)(128)), ((System.Byte)(128)));
			this.colDispEditNo.Fixed = true;
			this.colDispEditNo.Name = "colDispEditNo";
			this.colDispEditNo.Width = 25;
			this.colDispEditNo.WidthPercent = 35;
			// 
			// colDispEditCheck
			// 
			this.colDispEditCheck.BackColorCell = System.Drawing.Color.FromArgb(((System.Byte)(255)), ((System.Byte)(192)), ((System.Byte)(192)));
			this.colDispEditCheck.BackColorCellGradient = System.Drawing.Color.FromArgb(((System.Byte)(255)), ((System.Byte)(224)), ((System.Byte)(192)));
			this.colDispEditCheck.CellGradientMode = ppsGrid.eGradientMode.Vertical;
			this.colDispEditCheck.Name = "colDispEditCheck";
			this.colDispEditCheck.WidthPercent = 100;
			this.colDispEditCheck.WidthType = ppsGrid.eWidthType.Percent;
			// 
			// chkEdit
			// 
			this.chkEdit.Name = "chkEdit";
			this.chkEdit.Size = new System.Drawing.Size(80, 24);
			this.chkEdit.TabIndex = 6;
			this.chkEdit.Text = "checkBox1";
			this.chkEdit.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// rowDispEditFixed
			// 
			this.rowDispEditFixed.Fixed = true;
			this.rowDispEditFixed.Name = "rowDispEditFixed";
			// 
			// colCombo
			// 
			this.colCombo.Dock = System.Windows.Forms.DockStyle.Fill;
			this.colCombo.Items.AddRange(new object[] {
																									this.rowDispEditFixed});
			this.colCombo.MaxDropDownItems = 12;
			this.colCombo.Name = "colCombo";
			this.colCombo.Size = new System.Drawing.Size(0, 20);
			this.colCombo.TabIndex = 5;
			// 
			// frmCtrlCheckbox
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(414, 323);
			this.Controls.AddRange(new System.Windows.Forms.Control[] {
																																	this.label3,
																																	this.grdDispEdit,
																																	this.grdDisp,
																																	this.grdEdit,
																																	this.label2,
																																	this.label1});
			this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.Fixed3D;
			this.MaximizeBox = false;
			this.MinimizeBox = false;
			this.Name = "frmCtrlCheckbox";
			this.Text = "frmCtrlCheckbox";
			this.ResumeLayout(false);

		}
		#endregion

	}
}
