using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Text;
using ppsGrid;

namespace grdDemo.frm{
	/// <summary>
	/// Summary description for frmCtrlCheckbox.
	/// </summary>
	public class frmCtrlPosition : System.Windows.Forms.Form	{
		private System.Windows.Forms.Label label1;
		private ppsGrid.GridRow rowDispFixed;
		private ppsGrid.GridCol colPosNo;
		private ppsGrid.GridCol colPosMenge;
		private ppsGrid.Grid grdPos;
		private ppsGrid.GridCol colPosME;
		private ppsGrid.GridCol colPosText;
		private ppsGrid.GridCol colPosPE;
		private ppsGrid.GridCol colPosGewicht;
		private ppsGrid.GridCol colPosEinzel;
		private ppsGrid.GridCol colPosGesamt;
		private ppsGrid.GridCol colPosLiefDatum;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public frmCtrlPosition(){
			InitializeComponent();
		}
		/// <summary>Rechnungsposittionen initialisieren</summary>
		public void Init(){
			Random					rnd=new Random();																// allgemein Zufallsgenerator
			TextBox					txtText;																				// Textbox fr die Spalte "Text"
			NumericUpDown		nmcDouble;																			// Numeric fr Menge, Einzelpreis und Gewicht
			ComboBox				cboEinheit;																			// Combobox fr Mengen- und Preiseinheit
			DateTimePicker	dtePick;																				// DateTimePicker fr Lieferdatum

			string[]				einh=new String[]	{															// Einheiten
																			 "Stk.","kg","mtr.","Tafel","Sack",
																			 "Std.","qm","lfdm.","ltr.","Pckg.","cbm"};
			int[]						mnge=new int[]		{1,2,5,10,20,25,100};					// Mengen
			string[]				txte=new String[] {															// Texte
																				"Amiga 1000, 68000, Tastatur, Maus, 512 kByte RAM, Diskette 3.5\", Kickstart 1.1, Workbench 1.2",
																				"IBM PC XT, 8088, 4.77 Mhz, 512 kByte RAM, Diskette 5.25\"",
																				"Apple Macintosh, 68000 8 Mhz, Diskette 3.5\" 800 kByte, MacOs, Finder",
																				"Atari ST, 68000 8 Mhz, Diskette 3.5\", TOS 1.0, GEM",
																				"Netzwerkkabel, CAT 5, Twisted Pair 2xRJ45, Lnge 5 mtr.",
																				"Modem, 56k, seriell, Fabrikat Acer, Protokoll V.92",
																				"DVD-RW, Rohling, 25 Stk. Spindel, 4.7 Gbyte, 4x Speed",
																				"Drucker, 9 Nadel, Fabrikat Commodore, Typ MPS801",
																				"Netzwerkkarte, Fabrikat DLink, Ethernet 10/100 MBit, PCI32, LED-Anzeige",
																				"CPU, Fabrikat AMD, Typ Athon 64, 3000+, Sockel 939, 512 KByte L2-Cache",
																				"Festplatte, Fabrikat Western Digital, Typ WD360GD, 8 MByte Cache, 10.000 U/Min., Anschlu Serial-ATA, 3.55\", 1/3 Bauhhe",
																				"Grafikkarte, 256 MByte GDDR3-SDRAM, AGP 8x, Proz. ATI Radeon X700 pro, TV-Out Schnittstelle",
																				"Arbeitsspeicher, 1024 MByte, Fabrikat Infinion, DDR-PC400, ECC, CL3, DRAM, Bauform DIMM 184-PIN",
																				"Betriebssystem, Linux, Fabrikat Suse, Version 9.3 Prof., 5 DVD's, Handbuch",
																				"DVB-T Receiver, Fabrikat Siemens, Typ M740 AV, Dual DVB-T Tuner, Fernbedienung, Ethernet, USB",
																				"Digitalkamera, Fabrikat Canon, Typ IXUS i5, 5 MPixel, SD-Karte 32 MB, eingebauter Blitz, 1.5\" Farbdisplay, Gewicht 100g",
																				"Speicherkarte, Fabrikat Corsair, 1024 MByte, Geschw. 40fach, Flash",
																				"DVD-Brenner, Fabrikat BenQ, DVDRW-Laufwerk, IDE-Schnittstelle, Intern, CD:24x/ DVD:4x, Cache 2MByte",
																				"Motherboard, Fabrikat Asus, Typ A8N-SLI, Chipsatz nForce4, Sockel 939, ATA133+SATA150, Gigabit-Ethernet",
																				"Soundkarte, Fabrikat Creative, Typ Live 24Bit PCI, 7.1 Surround, DAC 24 Bit"
																			};

			
			
			grdPos.PreferredRowHeight=44;																				// voreingestellte Hhe fr neue Zeilen
			grdPos.AddRows(20);																									// 20 Positionen

			txtText=new TextBox();																							// Textbox zum editieren der Texte
			txtText.Dock=DockStyle.Fill;																				// ..fllt die Zelle komplett aus
			txtText.BorderStyle=BorderStyle.None;																// ..kein Rand
			txtText.ScrollBars=ScrollBars.Vertical;
			txtText.Multiline=true;																							// ..mehrere Zeilen anzeigen
			txtText.AcceptsReturn=true;																					// Eingabe beenden mit 'STRG'+Return
			grdPos["colPosText",0].Value="Text";																// ..Spaltentitel

			grdPos.Cols["colPosText"].CellPadding.All=0;												// ..kein zustzlicher Randabstand
			grdPos.Cols["colPosText"].ControlEditInfo.Control=txtText;					// ..Textbox fr Eingaben der Spalte "Text" setzen
			grdPos.Cols["colPosText"].ControlEditInfo.PropertyName="Text";			// .."Textbox.Text" ist die Eigenschaft fr lesen/schreiben

			grdPos["colPosText",1].Font=new Font("Tahoma",10);
			grdPos["colPosText",2].Font=new Font("Tahoma",12);
			grdPos["colPosText",3].Font=new Font("Tahoma",16);
			grdPos["colPosText",4].Font=new Font("Tahoma",24);

			nmcDouble=new NumericUpDown();																			// NumericUpDown fr Menge
			nmcDouble.Dock=DockStyle.Top;																				// ..am oberen Rand andocken der Zelle
			nmcDouble.BorderStyle=BorderStyle.None;															// ..kein rand
			nmcDouble.Increment=(Decimal)0.25;																	// ..Vernderung der Werte um "0.25"
			nmcDouble.Maximum=100;																							// ..Max. "1000"
			nmcDouble.DecimalPlaces=2;																					// ..2stellig anzeigen
			nmcDouble.TextChanged+=new EventHandler(nmc_TextChanged);						// ..zustzlich reagieren bei Wertenderung
			grdPos["colPosMenge",0].Value="Menge";															// ..Titel fr Spalte "Menge"
			grdPos.Cols["colPosMenge"].ControlEditInfo.Control=nmcDouble;				// ..Eingabe durch "NumericUpDown"
			grdPos.Cols["colPosMenge"].ControlEditInfo.PropertyName="Value";		// ..Eigenschaft "Value" fr lesen/schreiben

			nmcDouble=new NumericUpDown();																			// NumericUpDown fr Gewicht
			nmcDouble.Dock=DockStyle.Top;																				// ..am oberen Rand andocken der Zelle
			nmcDouble.BorderStyle=BorderStyle.None;															// ..kein rand
			nmcDouble.Increment=(Decimal)1.0	;																	// ..Vernderung der Werte um "0.25"
			nmcDouble.Maximum=1000;																							// ..Max. "1000"
			nmcDouble.DecimalPlaces=3;																					// ..2stellig anzeigen
			nmcDouble.TextChanged+=new EventHandler(nmc_TextChanged);						// ..zustzlich reagieren bei Wertenderung
			grdPos["colPosGewicht",0].Value="Gewicht";													// ..Titel fr Spalte "Gewicht"
			grdPos.Cols["colPosGewicht"].ControlEditInfo.Control=nmcDouble;			// ..Eingabe durch "NumericUpDown"
			grdPos.Cols["colPosGewicht"].ControlEditInfo.PropertyName="Value";	// ..Eigenschaft "Value" fr lesen/schreiben

			nmcDouble=new NumericUpDown();																			// NumericUpDown fr Preis
			nmcDouble.Dock=DockStyle.Top;																				// ..am oberen Rand andocken der Zelle
			nmcDouble.BorderStyle=BorderStyle.None;															// ..kein rand
			nmcDouble.Increment=(Decimal)0.01;																	// ..Vernderung der Werte um "0.25"
			nmcDouble.Maximum=1000;																							// ..Max. "1000"
			nmcDouble.DecimalPlaces=2;																					// ..2stellig anzeigen
			nmcDouble.TextChanged+=new EventHandler(nmc_TextChanged);						// ..zustzlich reagieren bei Wertenderung
			grdPos["colPosEinzel",0].Value="Einzelpreis";												// ..Titel fr Spalte "Einzelpreis"
			grdPos["colPosGesamt",0].Value="Gesamtpreis";												// ..Titel fr Spalte "Gesamtpreis"
			grdPos.Cols["colPosEinzel"].ControlEditInfo.Control=nmcDouble;			// ..Eingabe durch "NumericUpDown"
			grdPos.Cols["colPosEinzel"].ControlEditInfo.PropertyName="Value";		// ..Eigenschaft "Value" fr lesen/schreiben


			cboEinheit=new ComboBox();																					// ComboBox fr Mengeneinheit
			cboEinheit.Dock=DockStyle.Top;																			// ..andocken am oberen rand der Zelle
			cboEinheit.Items.AddRange(einh);																		// ..Einheiten einfgen
			grdPos["colPosME",0].Value="Mengeneinheit";													// ..Titel fr Mengeneinheit
			grdPos.Cols["colPosME"].ControlEditInfo.Control=cboEinheit;					// ..Steuerelement "ComboBox" fr Spalte "Mengeneinheit"
			grdPos.Cols["colPosME"].ControlEditInfo.PropertyName="SelectedItem";// ..Eigenschaft "SelectItem" fr lesen/schreiben

			cboEinheit=new ComboBox();																					// ComboBox fr Preiseinheit
			cboEinheit.Dock=DockStyle.Top;																			// ..andocken am oberen rand der Zelle
			cboEinheit.Items.AddRange(einh);																		// ..Einheiten einfgen
			grdPos["colPosPE",0].Value="Preiseinheit";													// ..Titel fr Preiseinheit			
			grdPos.Cols["colPosPE"].ControlEditInfo.Control=cboEinheit;					// ..Steuerelement "ComboBox" fr Spalte "Preiseinheit"
			grdPos.Cols["colPosPE"].ControlEditInfo.PropertyName="SelectedItem";// ..Eigenschaft "SelectItem" fr lesen/schreiben

			dtePick=new DateTimePicker();																				// DateTimePicker fr Lieferdatum
			dtePick.Format=DateTimePickerFormat.Short;													// ..kurzes Format
			dtePick.Dock=DockStyle.Top;																					// ..andocken am oberen rand der Zelle
			grdPos["colPosLiefDatum",0].Value="Lieferdatum";										// ..Titel fr Lieferdatum
			grdPos.Cols["colPosLiefDatum"].ControlEditInfo.Control=dtePick;			// ..Steuerelement "DateTimePicker" fr Spalte "Lieferdatum"
			grdPos.Cols["colPosLiefDatum"].ControlEditInfo.PropertyName="Value";// .."Value" ist Eigenschaft fr lesen/schreiben

			
			// Alle Zellen initialisieren  (wrde normalerweise aus der Datenbank passieren)
			for(int rw=0;rw<txte.Length;rw++){																	
				decimal		tmp;
				DateTime	today=DateTime.Today;

				grdPos["colPosText",rw+1].Value=txte[rw];																// Texte
				grdPos["colPosMenge",rw+1].Value=(Decimal)mnge[rnd.Next(mnge.Length)];	// Menge
				grdPos["colPosME",rw+1].Value=einh[rnd.Next(einh.Length)];							// Mengeneinheit
				grdPos["colPosPE",rw+1].Value=einh[rnd.Next(einh.Length)];							// Preiseinheit
				grdPos["colPosGewicht",rw+1].Value=(Decimal)rnd.Next(100);							// Gewicht
				grdPos["colPosEinzel",rw+1].Value=(Decimal)(rnd.Next(1000)+.95);				// Einzelpreis
				grdPos["colPosLiefDatum",rw+1].Value=today.AddDays(rnd.Next(90));				// Lieferdatum

				tmp=(decimal)grdPos["colPosMenge",rw+1].Value;
				tmp*=(decimal)grdPos["colPosEinzel",rw+1].Value;
				grdPos["colPosGesamt",rw+1].Value=tmp;																	// Gesamtpreis
			}
		}

		
		
		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing ){
			if( disposing ){
				if(components != null){
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}
		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.grdPos = new ppsGrid.Grid();
			this.colPosNo = new ppsGrid.GridCol();
			this.colPosMenge = new ppsGrid.GridCol();
			this.colPosME = new ppsGrid.GridCol();
			this.colPosText = new ppsGrid.GridCol();
			this.colPosPE = new ppsGrid.GridCol();
			this.colPosGewicht = new ppsGrid.GridCol();
			this.colPosEinzel = new ppsGrid.GridCol();
			this.colPosGesamt = new ppsGrid.GridCol();
			this.colPosLiefDatum = new ppsGrid.GridCol();
			this.rowDispFixed = new ppsGrid.GridRow();
			this.label1 = new System.Windows.Forms.Label();
			this.SuspendLayout();
			// 
			// grdPos
			// 
			this.grdPos.Anchor = (((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right);
			this.grdPos.Cols.AddRange(new object[] {
																							 this.colPosNo,
																							 this.colPosMenge,
																							 this.colPosME,
																							 this.colPosText,
																							 this.colPosPE,
																							 this.colPosGewicht,
																							 this.colPosEinzel,
																							 this.colPosGesamt,
																							 this.colPosLiefDatum});
			this.grdPos.FixedRowType = (ppsGrid.eFixedRowType.Moveable | ppsGrid.eFixedRowType.Sizeable);
			this.grdPos.Font = new System.Drawing.Font("Tahoma", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.grdPos.Location = new System.Drawing.Point(16, 24);
			this.grdPos.Name = "grdPos";
			this.grdPos.PreferredRowHeight = 24;
			this.grdPos.Rows.AddRange(new object[] {
																							 this.rowDispFixed});
			this.grdPos.SelectionType = ppsGrid.eSelectionType.None;
			this.grdPos.Size = new System.Drawing.Size(600, 232);
			this.grdPos.TabIndex = 0;
			// 
			// colPosNo
			// 
			this.colPosNo.AutoNumber = true;
			this.colPosNo.Fixed = true;
			this.colPosNo.Name = "colPosNo";
			this.colPosNo.Width = 20;
			// 
			// colPosMenge
			// 
			this.colPosMenge.FormatString = "0.00";
			this.colPosMenge.Name = "colPosMenge";
			this.colPosMenge.StringAlignHorz = ppsGrid.eContentAlign.Far;
			this.colPosMenge.Width = 60;
			// 
			// colPosME
			// 
			this.colPosME.Name = "colPosME";
			this.colPosME.Width = 60;
			// 
			// colPosText
			// 
			this.colPosText.Name = "colPosText";
			this.colPosText.WidthPercent = 100;
			this.colPosText.WidthType = ppsGrid.eWidthType.Percent;
			// 
			// colPosPE
			// 
			this.colPosPE.Name = "colPosPE";
			this.colPosPE.Width = 60;
			// 
			// colPosGewicht
			// 
			this.colPosGewicht.FormatString = "0.00 kg";
			this.colPosGewicht.Name = "colPosGewicht";
			this.colPosGewicht.StringAlignHorz = ppsGrid.eContentAlign.Far;
			this.colPosGewicht.Width = 50;
			// 
			// colPosEinzel
			// 
			this.colPosEinzel.FormatString = "C";
			this.colPosEinzel.Name = "colPosEinzel";
			this.colPosEinzel.StringAlignHorz = ppsGrid.eContentAlign.Far;
			this.colPosEinzel.Width = 60;
			// 
			// colPosGesamt
			// 
			this.colPosGesamt.FormatString = "C";
			this.colPosGesamt.Name = "colPosGesamt";
			this.colPosGesamt.StringAlignHorz = ppsGrid.eContentAlign.Far;
			// 
			// colPosLiefDatum
			// 
			this.colPosLiefDatum.FormatString = "dd.MM.yy";
			this.colPosLiefDatum.Name = "colPosLiefDatum";
			// 
			// rowDispFixed
			// 
			this.rowDispFixed.Fixed = true;
			this.rowDispFixed.Name = "rowDispFixed";
			// 
			// label1
			// 
			this.label1.Anchor = ((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right);
			this.label1.Font = new System.Drawing.Font("Microsoft Sans Serif", 9F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.label1.Location = new System.Drawing.Point(16, 0);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(592, 16);
			this.label1.TabIndex = 1;
			this.label1.Text = "Rechnungspositionen";
			this.label1.TextAlign = System.Drawing.ContentAlignment.TopCenter;
			// 
			// frmCtrlPosition
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(624, 261);
			this.Controls.AddRange(new System.Windows.Forms.Control[] {
																																	this.label1,
																																	this.grdPos});
			this.Name = "frmCtrlPosition";
			this.Text = "frmCtrlRichText";
			this.ResumeLayout(false);

		}
		#endregion

		public void nmc_TextChanged(object sender,EventArgs e){
			NumericUpDown	updn;
			int						col=grdPos.FocusCell.X,row=grdPos.FocusCell.Y;
			decimal				ezl,mng;
			string				colName=grdPos.Cols[col].Name;

			switch(colName){
				case "colPosMenge":
					updn=(NumericUpDown)grdPos.Cols["colPosMenge"].ControlEditInfo.Control;
					mng=updn.Value;
					ezl=(decimal)grdPos["colPosEinzel",row].Value;
					grdPos["colPosGesamt",row].Value=mng*ezl;
					break;
				case "colPosEinzel":
					mng=(decimal)grdPos["colPosMenge",row].Value;
					updn=(NumericUpDown)grdPos.Cols["colPosEinzel"].ControlEditInfo.Control;
					ezl=updn.Value;
					grdPos["colPosGesamt",row].Value=mng*ezl;
					break;
			}

		}

	}
}
