using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Text;
using ppsGrid;

namespace grdDemo.frm{
	/// <summary>
	/// Summary description for frmCtrlCheckbox.
	/// </summary>
	public class frmCtrlRichtextbox : System.Windows.Forms.Form	{
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.Label label2;
		private System.Windows.Forms.Label label3;
		private ppsGrid.GridRow rowDispFixed;
		private ppsGrid.GridRow rowEditFixed;
		private ppsGrid.GridRow rowDispEditFixed;
		private ppsGrid.GridCol colDispEditNo;
		private ppsGrid.GridCol colEditNo;
		private ppsGrid.GridCol colDispNo;
		private ppsGrid.Grid grdDisp;
		private ppsGrid.Grid grdEdit;
		private ppsGrid.Grid grdDispEdit;
		private ppsGrid.GridCol colDispText;
		private ppsGrid.GridCol colEditText;
		private ppsGrid.GridCol colDispEditText;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public frmCtrlRichtextbox(){
			InitializeComponent();
		}
		public void Init(){
			RichTextBox	rtf;
			Random			rnd=new Random();
			int					y=0;

			rtf=new RichTextBox();
			rtf.Dock=DockStyle.Fill;
			rtf.BorderStyle=BorderStyle.None;
			rtf.LoadFile(Application.StartupPath+"\\RTFdemo.rtf");
			grdDisp.PreferredRowHeight=96;
			grdDisp.AddRows(20);
			grdDisp.Cols["colDispText"].ControlDisplayInfo.Control=rtf;
			grdDisp.Cols["colDispText"].ControlDisplayInfo.PropertyName="Rtf";
			foreach(GridRow r in grdDisp.Rows)
				if(r.Fixed==false)
					r["colDispText"].Value=rtf.Rtf;


			rtf=new RichTextBox();
			rtf.Dock=DockStyle.Fill;
			rtf.BorderStyle=BorderStyle.None;
			rtf.LoadFile(Application.StartupPath+"\\RTFdemo.rtf");
			grdEdit.PreferredRowHeight=64;
			grdEdit.AddRows(20);
			grdEdit.Cols["colEditText"].ControlEditInfo.Control=rtf;
			grdEdit.Cols["colEditText"].ControlEditInfo.PropertyName="Rtf";
			foreach(GridRow r in grdEdit.Rows)
				if(r.Fixed==false)
					r["colEditText"].Value=rtf.Rtf;

		
			rtf=new RichTextBox();
			rtf.Dock=DockStyle.Fill;
			rtf.BorderStyle=BorderStyle.None;
			rtf.LoadFile(Application.StartupPath+"\\RTFdemo.rtf");
			grdDispEdit.Cols["colDispEditText"].ControlDisplayInfo.Control=rtf;
			grdDispEdit.Cols["colDispEditText"].ControlDisplayInfo.PropertyName="Rtf";

			rtf=new RichTextBox();
			rtf.Dock=DockStyle.Fill;
			rtf.BorderStyle=BorderStyle.None;
			rtf.LoadFile(Application.StartupPath+"\\RTFdemo.rtf");
			grdDispEdit.Cols["colDispEditText"].ControlEditInfo.Control=rtf;
			grdDispEdit.Cols["colDispEditText"].ControlEditInfo.PropertyName="Rtf";


			grdDispEdit.PreferredRowHeight=96;
			grdDispEdit.AddRows(20);
		
			while(y<grdDispEdit.Rows.Count){												// bis zur letzten Zeile
				GridRow	row = grdDispEdit.Rows[y];										// ..Zeile..
				if(rnd.Next(12) > 4+row.Outline.Level)								// ..per Zufall: ...
					row.Outline.AddChilds(rnd.Next(4)+1);								// ....neue "Childs" anhngen
				row[0].Value = "Zeile "+row.Row;											// ..Zeilennummer anzeigen
				y++;																									// ..nchste Zeile
			}

		

			foreach(GridRow r in grdDispEdit.Rows)
				if(r.Fixed==false)
					r["colDispEditText"].Value=rtf.Rtf;
		}

		
		
		public static string RandomString(Random rnd,int max){
			int			cnt=rnd.Next(max);
			byte[]	bff=new byte[max];

			for(int i=0;i<cnt;i++)
				bff[i]=(byte)rnd.Next(97,97+26);
			return(Encoding.ASCII.GetString(bff,0,cnt));
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(frmCtrlRichtextbox));
			this.grdDisp = new ppsGrid.Grid();
			this.rowDispFixed = new ppsGrid.GridRow();
			this.colDispNo = new ppsGrid.GridCol();
			this.colDispText = new ppsGrid.GridCol();
			this.grdEdit = new ppsGrid.Grid();
			this.rowEditFixed = new ppsGrid.GridRow();
			this.colEditNo = new ppsGrid.GridCol();
			this.colEditText = new ppsGrid.GridCol();
			this.label1 = new System.Windows.Forms.Label();
			this.label2 = new System.Windows.Forms.Label();
			this.label3 = new System.Windows.Forms.Label();
			this.grdDispEdit = new ppsGrid.Grid();
			this.rowDispEditFixed = new ppsGrid.GridRow();
			this.colDispEditNo = new ppsGrid.GridCol();
			this.colDispEditText = new ppsGrid.GridCol();
			this.SuspendLayout();
			// 
			// grdDisp
			// 
			this.grdDisp.Anchor = ((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Left);
			this.grdDisp.BottomRow = this.rowDispFixed;
			this.grdDisp.Cols.AddRange(new object[] {
																								this.colDispNo,
																								this.colDispText});
			this.grdDisp.ControlEditInfo.Control = null;
			this.grdDisp.FixedRowType = (ppsGrid.eFixedRowType.Moveable | ppsGrid.eFixedRowType.Sizeable);
			this.grdDisp.LeftCol = this.colDispText;
			this.grdDisp.Location = new System.Drawing.Point(16, 24);
			this.grdDisp.Name = "grdDisp";
			this.grdDisp.PreferredRowHeight = 24;
			this.grdDisp.RightCol = this.colDispText;
			this.grdDisp.Rows.AddRange(new object[] {
																								this.rowDispFixed});
			this.grdDisp.SelectionType = ppsGrid.eSelectionType.None;
			this.grdDisp.Size = new System.Drawing.Size(200, 106);
			this.grdDisp.TabIndex = 0;
			this.grdDisp.TopRow = this.rowDispFixed;
			// 
			// rowDispFixed
			// 
			this.rowDispFixed.Fixed = true;
			this.rowDispFixed.Name = "rowDispFixed";
			// 
			// colDispNo
			// 
			this.colDispNo.AutoNumber = true;
			this.colDispNo.Fixed = true;
			this.colDispNo.Name = "colDispNo";
			this.colDispNo.Width = 25;
			this.colDispNo.WidthPercent = 35;
			// 
			// colDispText
			// 
			this.colDispText.Name = "colDispText";
			this.colDispText.WidthPercent = 100;
			this.colDispText.WidthType = ppsGrid.eWidthType.Percent;
			// 
			// grdEdit
			// 
			this.grdEdit.Anchor = ((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Left);
			this.grdEdit.BottomRow = this.rowEditFixed;
			this.grdEdit.Cols.AddRange(new object[] {
																								this.colEditNo,
																								this.colEditText});
			this.grdEdit.ControlEditInfo.Control = null;
			this.grdEdit.FixedRowType = (ppsGrid.eFixedRowType.Moveable | ppsGrid.eFixedRowType.Sizeable);
			this.grdEdit.LeftCol = this.colEditText;
			this.grdEdit.Location = new System.Drawing.Point(224, 24);
			this.grdEdit.Name = "grdEdit";
			this.grdEdit.RightCol = this.colEditText;
			this.grdEdit.Rows.AddRange(new object[] {
																								this.rowEditFixed});
			this.grdEdit.SelectionType = ppsGrid.eSelectionType.None;
			this.grdEdit.Size = new System.Drawing.Size(216, 106);
			this.grdEdit.TabIndex = 0;
			this.grdEdit.TopRow = this.rowEditFixed;
			// 
			// rowEditFixed
			// 
			this.rowEditFixed.Fixed = true;
			this.rowEditFixed.Name = "rowEditFixed";
			// 
			// colEditNo
			// 
			this.colEditNo.AutoNumber = true;
			this.colEditNo.Fixed = true;
			this.colEditNo.Name = "colEditNo";
			this.colEditNo.Width = 25;
			this.colEditNo.WidthPercent = 35;
			// 
			// colEditText
			// 
			this.colEditText.Name = "colEditText";
			this.colEditText.WidthPercent = 100;
			this.colEditText.WidthType = ppsGrid.eWidthType.Percent;
			// 
			// label1
			// 
			this.label1.Location = new System.Drawing.Point(16, 8);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(192, 16);
			this.label1.TabIndex = 1;
			this.label1.Text = "nur Anzeige";
			this.label1.TextAlign = System.Drawing.ContentAlignment.TopCenter;
			// 
			// label2
			// 
			this.label2.Location = new System.Drawing.Point(216, 8);
			this.label2.Name = "label2";
			this.label2.Size = new System.Drawing.Size(224, 16);
			this.label2.TabIndex = 2;
			this.label2.Text = "nur Editieren";
			this.label2.TextAlign = System.Drawing.ContentAlignment.TopCenter;
			// 
			// label3
			// 
			this.label3.Anchor = ((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right);
			this.label3.Location = new System.Drawing.Point(448, 8);
			this.label3.Name = "label3";
			this.label3.Size = new System.Drawing.Size(168, 16);
			this.label3.TabIndex = 4;
			this.label3.Text = "Anzeige+Editieren";
			this.label3.TextAlign = System.Drawing.ContentAlignment.TopCenter;
			// 
			// grdDispEdit
			// 
			this.grdDispEdit.Anchor = (((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right);
			this.grdDispEdit.BottomRow = this.rowDispEditFixed;
			this.grdDispEdit.Cols.AddRange(new object[] {
																										this.colDispEditNo,
																										this.colDispEditText});
			this.grdDispEdit.ControlEditInfo.Control = null;
			this.grdDispEdit.FixedRowType = (ppsGrid.eFixedRowType.Moveable | ppsGrid.eFixedRowType.Sizeable);
			this.grdDispEdit.LeftCol = this.colDispEditText;
			this.grdDispEdit.Location = new System.Drawing.Point(448, 24);
			this.grdDispEdit.Name = "grdDispEdit";
			this.grdDispEdit.PreferredRowHeight = 24;
			this.grdDispEdit.RightCol = this.colDispEditText;
			this.grdDispEdit.Rows.AddRange(new object[] {
																										this.rowDispEditFixed});
			this.grdDispEdit.ScrollSmooth = -1;
			this.grdDispEdit.SelectionType = ppsGrid.eSelectionType.None;
			this.grdDispEdit.Size = new System.Drawing.Size(176, 106);
			this.grdDispEdit.TabIndex = 3;
			this.grdDispEdit.TopRow = this.rowDispEditFixed;
			this.grdDispEdit.KeyDown += new System.Windows.Forms.KeyEventHandler(this.grdDispEdit_KeyDown);
			// 
			// rowDispEditFixed
			// 
			this.rowDispEditFixed.Fixed = true;
			this.rowDispEditFixed.Name = "rowDispEditFixed";
			// 
			// colDispEditNo
			// 
			this.colDispEditNo.AutoNumber = true;
			this.colDispEditNo.Fixed = true;
			this.colDispEditNo.Name = "colDispEditNo";
			this.colDispEditNo.Width = 25;
			this.colDispEditNo.WidthPercent = 35;
			// 
			// colDispEditText
			// 
			this.colDispEditText.Name = "colDispEditText";
			this.colDispEditText.OutlineMode = true;
			this.colDispEditText.WidthPercent = 100;
			this.colDispEditText.WidthType = ppsGrid.eWidthType.Percent;
			// 
			// frmCtrlRichtextbox
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(632, 133);
			this.Controls.AddRange(new System.Windows.Forms.Control[] {
																																	this.label3,
																																	this.grdDispEdit,
																																	this.grdDisp,
																																	this.grdEdit,
																																	this.label2,
																																	this.label1});
			this.Name = "frmCtrlRichtextbox";
			this.Text = "frmCtrlRichText";
			this.ResumeLayout(false);

		}
		#endregion

		private void grdDispEdit_KeyDown(object sender, System.Windows.Forms.KeyEventArgs e) {
			if(e.KeyCode==Keys.E)		grdDispEdit.BeginEdit();
		}
	}
}
