using System;
using System.Drawing;
using System.Collections;
using System.Windows.Forms;
using System.Diagnostics;
using ppsGrid;
using System.IO;
using System.Runtime.InteropServices;

namespace grdDemo.frm{
	public class frmExplorer : System.Windows.Forms.Form{
		private System.ComponentModel.IContainer components;
		private System.Windows.Forms.ImageList imgList;
		private ppsGrid.GridCol colName;
		private ppsGrid.GridRow rowTitle;
		private ppsGrid.GridCol colSize;
		private ppsGrid.Grid grdFile;
		private ppsGrid.GridCol colDir;
		private ppsGrid.Grid grdDir;
		private ppsGrid.GridCol colDate;
		private ppsGrid.GridCol colType;
		private ppsGrid.GridRow rowDir;
		private System.Windows.Forms.Splitter splitter1;
		private	int						vRowHeight=16;

		[DllImport("kernel32.dll", CharSet=CharSet.Auto, SetLastError=false)]
		public static extern int GetDriveType(string rootPathName);

		public frmExplorer(){
			InitializeComponent();																					// controls initialisieren
		}

		public void Init(){
			string[]				drv;
			DirectoryInfo		dir;
			GridOutlineRow	oline;

			grdDir.Cells ["colDir",0].Value="Ordner";											// titel dirGrid
			grdFile.Cells["colName",0].Value="Name";												// namen fileGrid
			grdFile.Cells["colDate",0].Value="Datum";												// (creation-)Datum fileGrid
			grdFile.Cells["colSize",0].Value="Gre";												// fileSize fileGrid
			grdFile.Cells["colType",0].Value="Typ";													// fileTyp fileGrid

			grdFile.Cells["colType",0].BackColorFixed=Color.FromKnownColor(KnownColor.Yellow);


			drv=System.Environment.GetLogicalDrives();											// laufwerke
			grdDir.AddRows(drv.Length);																			// alle zeilen erzeugen

			for(int i=0;i<drv.Length;i++){																	// laufwerke..
				grdDir.Cells["colDir",i+1].Value=drv[i];											// ..name zeigen
				grdDir.Rows[i+1].Height=vRowHeight;														// ..standard-Zeilenhhe
				grdDir.Rows[i+1].Tag=drv[i];																	// ..object speichern
				oline=grdDir.Rows[i+1].Outline;

//				switch(GetDriveType(drv[i])){
//					case 3:																											// DriveType.Fixed
//						oline.PictureOpen=(Bitmap)imgList.Images[0];
//						break;
//					case 5:																											// DriveType.CdRom
//						oline.PictureOpen=(Bitmap)imgList.Images[3];
//						break;
//					case 2:																											// DriveType.Removable
//						oline.PictureOpen=(Bitmap)imgList.Images[4];
//						break;
//					case 4:																											// DriveType.Remote
//						oline.PictureOpen=(Bitmap)imgList.Images[5];
//						break;
//					default:
//						oline.PictureOpen=(Bitmap)imgList.Images[0];
//						break;
//				}
//				oline.PictureNone=oline.PictureClose=oline.PictureOpen;

				try{
					dir=new DirectoryInfo(drv[i]);															// ..dirs or files avaible ?
					grdDir.Rows[i+1].Outline.HasChild=(HasDirOrFile(dir));			// ..pluszeichen (zum ffnen) anzeigen
				}
				catch{}
			}
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose(bool disposing){
			if(disposing)
				if(components!=null) 
					components.Dispose();
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent() {
			this.components = new System.ComponentModel.Container();
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(frmExplorer));
			this.splitter1 = new System.Windows.Forms.Splitter();
			this.rowDir = new ppsGrid.GridRow();
			this.colType = new ppsGrid.GridCol();
			this.colDate = new ppsGrid.GridCol();
			this.grdDir = new ppsGrid.Grid();
			this.colDir = new ppsGrid.GridCol();
			this.grdFile = new ppsGrid.Grid();
			this.colSize = new ppsGrid.GridCol();
			this.rowTitle = new ppsGrid.GridRow();
			this.colName = new ppsGrid.GridCol();
			this.imgList = new System.Windows.Forms.ImageList(this.components);
			this.SuspendLayout();
			// 
			// splitter1
			// 
			this.splitter1.Location = new System.Drawing.Point(212, 4);
			this.splitter1.Name = "splitter1";
			this.splitter1.Size = new System.Drawing.Size(8, 125);
			this.splitter1.TabIndex = 1;
			this.splitter1.TabStop = false;
			// 
			// rowDir
			// 
			this.rowDir.Fixed = true;
			this.rowDir.Name = "rowDir";
			// 
			// colType
			// 
			this.colType.Name = "colType";
			// 
			// colDate
			// 
			this.colDate.FormatString = "";
			this.colDate.Name = "colDate";
			// 
			// grdDir
			// 
			this.grdDir.BackColorColAlternate = System.Drawing.SystemColors.Info;
			this.grdDir.CellFrameType = ppsGrid.eCellFrameType.None;
			this.grdDir.Cols.AddRange(new object[] {
						this.colDir});
			this.grdDir.Dock = System.Windows.Forms.DockStyle.Left;
			this.grdDir.FixedColType = ppsGrid.eFixedColType.Sizeable;
			this.grdDir.FixedRowType = ppsGrid.eFixedRowType.None;
			this.grdDir.HideSelection = ppsGrid.eHighlight.None;
			this.grdDir.Location = new System.Drawing.Point(4, 4);
			this.grdDir.Name = "grdDir";
			this.grdDir.Rows.AddRange(new object[] {
						this.rowDir});
			this.grdDir.Size = new System.Drawing.Size(208, 125);
			this.grdDir.StringAlignVert = ppsGrid.eContentAlign.Center;
			this.grdDir.TabIndex = 0;
			this.grdDir.CellDoubleClick += new ppsGrid.OnCellDoubleClick(this.grdDir_CellDoubleClick);
			this.grdDir.SelectionEnd += new ppsGrid.OnSelectionEnd(this.grdDir_SelectionEnd);
			this.grdDir.BeforeExpand += new ppsGrid.OnBeforeExpand(this.grdDir_BeforeExpand);
			// 
			// colDir
			// 
			this.colDir.Name = "colDir";
			this.colDir.OutlineMode = true;
			this.colDir.WidthPercent = 100;
			this.colDir.WidthType = ppsGrid.eWidthType.Percent;
			// 
			// grdFile
			// 
			this.grdFile.BackColorColAlternate = System.Drawing.SystemColors.Info;
			this.grdFile.CellFrameType = ppsGrid.eCellFrameType.None;
			this.grdFile.Cols.AddRange(new object[] {
						this.colName,
						this.colDate,
						this.colSize,
						this.colType});
			this.grdFile.Dock = System.Windows.Forms.DockStyle.Fill;
			this.grdFile.HideSelection = ppsGrid.eHighlight.None;
			this.grdFile.Location = new System.Drawing.Point(220, 4);
			this.grdFile.Name = "grdFile";
			this.grdFile.Rows.AddRange(new object[] {
						this.rowTitle});
			this.grdFile.Scrollbar = ppsGrid.eScrollbar.Both;
			this.grdFile.Size = new System.Drawing.Size(344, 125);
			this.grdFile.StringAlignVert = ppsGrid.eContentAlign.Center;
			this.grdFile.TabIndex = 2;
			this.grdFile.CellDoubleClick += new ppsGrid.OnCellDoubleClick(this.grdFile_CellDoubleClick);
			// 
			// colSize
			// 
			this.colSize.Name = "colSize";
			// 
			// rowTitle
			// 
			this.rowTitle.Fixed = true;
			this.rowTitle.Name = "rowTitle";
			// 
			// colName
			// 
			this.colName.Name = "colName";
			// 
			// imgList
			// 
			this.imgList.ImageSize = new System.Drawing.Size(16, 16);
			this.imgList.TransparentColor = System.Drawing.Color.Transparent;
			// 
			// frmExplorer
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(568, 133);
			this.Controls.Add(this.grdFile);
			this.Controls.Add(this.splitter1);
			this.Controls.Add(this.grdDir);
			this.DockPadding.All = 4;
			this.Name = "frmExplorer";
			this.Text = "Explorer";
			this.ResumeLayout(false);
		}
		#endregion

//		/// <summary>
//		/// The main entry point for the application.
//		/// </summary>
//		[STAThread]
//		static void Main(){
//			Application.Run(new frmExplorer());
//		}



		/// <summary>prfen, of dateiname oder ordner vorhanden sind</summary>
		/// <param name="dir">verzeichnis, in dem gesucht wird</param>
		/// <returns>true:ja, false:nein</returns>
		public bool HasDirOrFile(DirectoryInfo dir){
			int	cnt=dir.GetDirectories().Length;														// anzahl der ordner
			if(cnt==0)																											// keine..
				cnt=dir.GetFiles().Length;																		// anzahl der dateien
			return(cnt>0);																									// true, wenn gefunden
		}
		/// <summary>prfen, of ordner vorhanden sind</summary>
		/// <param name="dir">verzeichnis, in dem gesucht wird</param>
		/// <returns>true:ja, false:nein</returns>
		public bool HasDir(DirectoryInfo dir){
			return(dir.GetDirectories().Length>0);													// anzahl der ordner>0, true
		}
		/// <summary>liest verzeichnisse und sortiert sie</summary>
		/// <param name="dir">verzeichnisse von diesem verzeichnis</param>
		/// <returns>sortierte verzeichnisse</returns>
		public FileSystemInfo[]	ReadDirectory(DirectoryInfo	dir){
			try{
				FileSystemInfo[]	srt=dir.GetDirectories();										// get dir (dirNames only)
				string[]					nms=new String[srt.Length];									// sortMem

				for(int c=0;c<srt.Length;c++)																	// alle..
					nms[c]=srt[c].Name;																					// ..namen kopieren
				Array.Sort(nms,srt);																					// sortieren
				return(srt);																									// sortierte liste zurck
			}
			catch{
				return(null);
			}
		}
		/// <summary>liest files und sortiert sie</summary>
		/// <param name="dir">files von diesem verzeichnis</param>
		/// <returns>sortierte files</returns>
		public FileSystemInfo[]	ReadFiles(DirectoryInfo	dir){
			FileSystemInfo[]	srt=dir.GetFiles();														// get dir (filenames only)
			string[]					nms=new String[srt.Length];										// sortMem

			for(int c=0;c<srt.Length;c++)																		// alle..
				nms[c]=srt[c].Name;																						// ..namen..
			Array.Sort(nms,srt);																						// sortieren
			return(srt);																										// sortierte liste zurck
		}

		/// <summary>unterordner ffnen</summary>
		/// <param name="sender">dirGrid</param>
		/// <param name="e">BeforeExpandEventArgs</param>
		private void grdDir_BeforeExpand(object sender, ppsGrid.BeforeExpandEventArgs e) {
			if(e.FirstTime){																								// dateien/ordner nur beim ersten mal lesen
				GridRow						row=grdDir.Rows[e.Row];											// angeklickte zeile
				string						drv=row.Outline.FullPath(0,@"\");						// kompletten Pfad ("c:\Windows\System32")
				DirectoryInfo			dir=new DirectoryInfo(drv);									// infos darber
				FileSystemInfo[]	srt;
				int								cnt=1;

				srt=this.ReadDirectory(dir);																	// dirs lesen und sortieren
				grdDir.Rows[e.Row].Outline.AddChilds(srt.Length);							// zeilen erzeugen
				foreach (DirectoryInfo d in srt){															// alle unterverzeichnisse
					row=grdDir.Rows[e.Row+cnt];																	// ..in diese zeile
					row.Height=vRowHeight;																			// ..hhe einstellen (standard 16, hier 20)
					
					grdDir.Cells[0,row.Row].Value=d.Name;												// ..name vom verzeichnis
// auch:  row[0].Value=d.Name;																				// ..name vom ...
// auch:	grdDir[0,row.Row].Value=d.Name;															// ..name vom ...

					row.Outline.HasChild=(HasDir(d));														// ..weitere unterverzeichnisse ? (plus anzeigen)
					row.Outline.PictureNone=(Bitmap)imgList.Images[1];					// ..image geschlossen
					row.Outline.PictureClose=(Bitmap)imgList.Images[1];					// ..dto.
					row.Outline.PictureOpen=(Bitmap)imgList.Images[2];					// ..image offen
					cnt++;																											// ..nchste zeile
				}
			}
		}

		/// <summary>neues verzeichnis markiert</summary>
		/// <param name="sender">grid Dir</param>
		/// <param name="e">SelectionEndEventArgs</param>
		private void grdDir_SelectionEnd(object sender, ppsGrid.SelectionEndEventArgs e) {
			GridRow						row=grdDir.Rows[e.Row];												// selected row
			string						drv=row.Outline.FullPath(0,@"\");							// kompletten Pfad ("c:\Windows\System32")
			
			try{
				DirectoryInfo			dir=new DirectoryInfo(drv);									// infos ber pfad
				FileSystemInfo[]	srt;
				int								cnt=grdFile.FixedRowCount;

				while(grdFile.Rows.Count>cnt)																	// alte ordner/dateien entfernen
					grdFile.Rows.RemoveAt(cnt);																	// ..erste zeile stehen lassen
				cnt=grdFile.FixedRowCount;

				srt=this.ReadDirectory(dir);																	// verzeichnisse lesen, sortieren
				grdFile.AddRows(srt.Length);																	// leerzeilen fr verzeichnisse
				foreach (DirectoryInfo d in srt)															// alle verzeichnisse
					this.DisplayDir(d,cnt++);																		// ..anzeigen

				srt=this.ReadFiles(dir);																			// files lesen, sortieren
				grdFile.AddRows(srt.Length);																	// leerzeilen fr files
				foreach (FileInfo f in srt)																		// alle files
					this.DisplayFile(f,cnt++);																	// ..anzeigen
			}
			catch{}
		}

		/// <summary>doppelklick in zelle in dirGrid</summary>
		/// <param name="sender">grid</param>
		/// <param name="e">welche zelle</param>
		private void grdDir_CellDoubleClick(object sender, ppsGrid.CellClickEventArgs e) {
			GridRow								row=grdDir.Rows[e.Row];										// geklickte zeile
			SelectionEndEventArgs	evt;

			if(row!=null){																										// ok ?
				row.Outline.OpenChild();																				// ..child's anzeigen
				evt=new SelectionEndEventArgs(e.Column,e.Row);									// ..argumnet fr event
				grdDir_SelectionEnd(sender,evt);																// ..in gridFile anzeigen
			}
		}

		/// <summary>doppelklick in zelle in fileGrid</summary>
		/// <param name="sender">fileGrid</param>
		/// <param name="e">welche zelle</param>
		private void grdFile_CellDoubleClick(object sender, ppsGrid.CellClickEventArgs e) {
//		GridRow	row=grdFile.SelectedRow;																// welche zeile
//			GridRow	row=(grdFile.Selection.Rows[0] as GridRow);
			GridRow	row=null;

			if(row!=null){																									// ok ?
				if(row.Tag.GetType()==typeof(DirectoryInfo)){									// zeile ist verzeichnis ?
					string dirName;
					
					dirName=(string)grdFile.Cells["colName",row.Row].Value;			// name vom verzeichnis
//				grdDir.SelectedRow.Outline.OpenChild();											// childs anzeigen
//				(grdDir.Selection.Rows[0] as GridRow).Outline.OpenChild();
					row=grdDir.Cols["colDir"].Search(dirName.Trim(),row.Row);	// angeklicktes verzeichnis suchen

					if(row!=null){																							// ok ?
//					grdDir.SelectedRow.Selected=false;												// altes verzeichnis deMarkieren
						grdDir.Selection.Clear();
						row.Selected=true;																				// neues verzeichnis markieren

						string						pth=row.Outline.FullPath(0,@"\");				// pfad holen
						DirectoryInfo			dir=new DirectoryInfo(pth);							// infos ber pfad
						FileSystemInfo[]	srt;
						int								cnt=grdFile.FixedRowCount;

						while(grdFile.Rows.Count>cnt)	
							grdFile.Rows.RemoveAt(cnt);
		
						srt=this.ReadDirectory(dir);															// verzeichnisse lesen, sortieren
						grdFile.AddRows(srt.Length);															// leerzeilen fr verzeichnisse
						foreach (DirectoryInfo d in srt)													// alle verzeichnisse
							this.DisplayDir(d,cnt++);																// ..anzeigen

						srt=this.ReadFiles(dir);																	// files lesen, sortieren
						grdFile.AddRows(srt.Length);															// leerzeilen fr files
						foreach (FileInfo f in srt)																// alle files
							this.DisplayFile(f,cnt++);															// ..anzeigen
					}
				}
			}
		}

		/// <summary>verzeichnis in fileGrid anzeigen</summary>
		/// <param name="di">verzeichnis</param>
		/// <param name="rw">zeile</param>
		public void DisplayDir(DirectoryInfo di,int rw){
			grdFile.Rows[rw].Height=vRowHeight;															// hhe einstellen (standard=16, hier 20)
			grdFile.Cells["colName",rw].Value="      "+di.Name;							// name
			grdFile.Cells["colSize",rw].Value=null;													// keine gre
			grdFile.Cells["colDate",rw].Value=di.CreationTime;								// erzeugerdatum
			grdFile.Rows[rw].Tag=di;																				// object speichern
			grdFile.Cells["colType",rw].Value="Dateiordner";									// typ
			grdFile.Cells["colName",rw].Image=(Bitmap)imgList.Images[1];			// abbildung
		}
		/// <summary>file im fileGrid anzeigen</summary>
		/// <param name="fi">datei</param>
		/// <param name="rw">zeile</param>
		public void DisplayFile(FileInfo fi,int rw){
			GridRow	row=grdFile.Rows[rw];
			string	ext=fi.Extension;																				// extension ".txt", ".doc", ".exe", ...)
			long		sz=fi.Length/1024;																			// gre in kilobytes
			if(sz<1)	sz=1;																									// min. 1 kb

			grdFile["colName",rw].Value="      "+fi.Name;							// name
			grdFile["colSize",rw].Value=sz.ToString()+" kb";					// gre
			grdFile["colDate",rw].Value=fi.CreationTime;							// erzeugerDatum
			if(ext.Length>0)																								// extension ok ?
				grdFile["colType",rw].Value=ext.Substring(1)+"-Datei";	// ..extension ohne punkt
			grdFile["colName",rw].Image=(Bitmap)imgList.Images[6];		// abbildung

			row.Height=vRowHeight;																					// rowHeight=20
			row.Tag=fi;																											// object speichern

		}
	}
}
