using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Drawing.Text;
using System.Diagnostics;
using System.IO;

using ppsGrid;

namespace grdDemo.frm{
	/// <summary>
	/// Summary description for frmGrid.
	/// </summary>
	public class frmGrid : System.Windows.Forms.Form{
		private ppsGrid.Grid grid;
		private ppsGrid.GridCol gridCol1;
		private ppsGrid.GridCol gridCol2;
		private ppsGrid.GridCol colFirst;
		private ppsGrid.GridCol colName;
		private ppsGrid.GridRow rowFirst;
		private ppsGrid.GridRow rowName;
		private System.Windows.Forms.RichTextBox richTextBox1;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public frmGrid() {
			InitializeComponent();
		}


		/// <summary>Init form</summary>
		public void Init(){
			grid.AddCols(5);
			grid.AddRows(5);

			grid[1,1].Value="Region/Datum";
			grid[1,2].Value="Europa";
			grid[1,3].Value="Afrika";
			grid[1,4].Value="Amerika";
			grid[1,5].Value="Asien";

			grid[1,1].Value="Region/Datum";
			grid[2,1].Value="2000";
			grid[3,1].Value="2001";
			grid[4,1].Value="2002";
			grid[5,1].Value="2003";

			for(int c=2;c<grid.Cols.Count;c++){
				grid.Cols[c].Outline.HasChild=true;
				grid.Rows[c].Outline.HasChild=true;
			}
		}





		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing ) {
			if( disposing ) {
				if(components != null) {
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent() {
			this.grid = new ppsGrid.Grid();
			this.colFirst = new ppsGrid.GridCol();
			this.colName = new ppsGrid.GridCol();
			this.rowFirst = new ppsGrid.GridRow();
			this.rowName = new ppsGrid.GridRow();
			this.gridCol1 = new ppsGrid.GridCol();
			this.gridCol2 = new ppsGrid.GridCol();
			this.richTextBox1 = new System.Windows.Forms.RichTextBox();
			this.SuspendLayout();
			// 
			// grid
			// 
			this.grid.Anchor = (((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right);
			this.grid.BackColorFixedGradient = System.Drawing.Color.FromArgb(((System.Byte)(0)), ((System.Byte)(0)), ((System.Byte)(64)));
			this.grid.Cols.AddRange(new object[] {
																						 this.colFirst,
																						 this.colName});
			this.grid.Location = new System.Drawing.Point(8, 8);
			this.grid.Name = "grid";
			this.grid.PreferredColWidth = 120;
			this.grid.Rows.AddRange(new object[] {
																						 this.rowFirst,
																						 this.rowName});
			this.grid.Scrollbar = ppsGrid.eScrollbar.Both;
			this.grid.ScrollbarVisible = ppsGrid.eScrollbarVisible.Required;
			this.grid.Size = new System.Drawing.Size(254, 117);
			this.grid.TabIndex = 0;
			this.grid.BeforeExpand += new ppsGrid.OnBeforeExpand(this.grid_BeforeExpand);
			// 
			// colFirst
			// 
			this.colFirst.AutoNumber = true;
			this.colFirst.Fixed = true;
			this.colFirst.Name = "colFirst";
			this.colFirst.Width = 25;
			// 
			// colName
			// 
			this.colName.Name = "colName";
			this.colName.OutlineMode = true;
			this.colName.Width = 80;
			// 
			// rowFirst
			// 
			this.rowFirst.Fixed = true;
			this.rowFirst.Height = 20;
			this.rowFirst.Name = "rowFirst";
			this.rowFirst.OutlineMode = true;
			// 
			// rowName
			// 
			this.rowName.Height = 48;
			this.rowName.Name = "rowName";
			this.rowName.OutlineMode = true;
			// 
			// gridCol1
			// 
			this.gridCol1.Fixed = true;
			this.gridCol1.Name = "gridCol1";
			// 
			// gridCol2
			// 
			this.gridCol2.BackColorCell = System.Drawing.Color.FromArgb(((System.Byte)(192)), ((System.Byte)(192)), ((System.Byte)(255)));
			this.gridCol2.BackColorCellGradient = System.Drawing.Color.Blue;
			this.gridCol2.Name = "gridCol2";
			this.gridCol2.WidthPercent = 100;
			this.gridCol2.WidthType = ppsGrid.eWidthType.Percent;
			// 
			// richTextBox1
			// 
			this.richTextBox1.Location = new System.Drawing.Point(314, 37);
			this.richTextBox1.Name = "richTextBox1";
			this.richTextBox1.Size = new System.Drawing.Size(210, 186);
			this.richTextBox1.TabIndex = 1;
			this.richTextBox1.Text = "richTextBox1";
			this.richTextBox1.MouseDown += new System.Windows.Forms.MouseEventHandler(this.richTextBox1_MouseDown);
			// 
			// frmGrid
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(545, 256);
			this.Controls.AddRange(new System.Windows.Forms.Control[] {
																																	this.richTextBox1,
																																	this.grid});
			this.DockPadding.All = 8;
			this.Name = "frmGrid";
			this.Text = "frmGrid";
			this.ResumeLayout(false);

		}
		#endregion

		private void grid_BeforeExpand(object sender, ppsGrid.BeforeExpandEventArgs e) {
			Random	rnd=new Random();
			string[,]	lnds=new string[,] { 
										{"Deutschland","Frankreich","Italien","Spanien","Schweiz"}, 
                    {"Kenia","Sdafrika","Ghana","gypten","Algerien"},
										{"Kanada","Mexiko","Bolivien","Peru","Brasilien"},
										{"Japan","Indien","Taiwan","China","Singapur"}
					};

			if(e.FirstTime && (e.Column!=1 || e.Row!=1)){
				if(grid.Cols[e.Column].OutlineMode){
					grid.Rows[e.Row].Outline.AddChilds(4);
					for(int c=2;c<6;c++)
						for(int r=0;r<4;r++){
							grid[1,r+e.Row+1].Value=lnds[e.Row-2,r];
							grid[c,r+e.Row+1].Value=rnd.Next(10000);
						}
				}
				if(grid.Rows[e.Row].OutlineMode){
					grid.Cols[e.Column].Outline.AddChilds(5);
					for(int c=0;c<4;c++)
						for(int r=2;r<6;r++){
							grid[c+e.Column+1,r].Value=rnd.Next(10000);
						}
				}
			}
		}

		private void richTextBox1_MouseDown(object sender, System.Windows.Forms.MouseEventArgs e) {
			Debugger.Break();
		}

	}
}