using System;
using System.Collections;
using System.ComponentModel;
using System.Drawing;
using System.Drawing.Text;
using System.Text;
using System.Windows.Forms;

using System.Diagnostics;

using ppsGrid;

namespace grdDemo.frm{
	public class frmOutlineCol:System.Windows.Forms.Form{
		private System.Windows.Forms.Label labHitTest;
		private System.Windows.Forms.TextBox txtHitTest;
		private ppsGrid.Grid grid;
		private ppsGrid.GridCol colLeft;
		private ppsGrid.GridRow rowNo;
		private ppsGrid.GridRow rowName;
		private ppsGrid.GridRow rowStadt;
		private ppsGrid.GridRow rowData;
		private ppsGrid.GridRow rowLevel;
		private ppsGrid.GridRow rowParent;
		private ppsGrid.GridRow rowFirstChild;
		private ppsGrid.GridRow rowLastChild;
		private ppsGrid.GridRow rowPrevCol;
		private ppsGrid.GridRow rowNextCol;
		private ppsGrid.GridRow rowPathName;
		private ppsGrid.GridRow rowPathStadt;
		private ppsGrid.GridColor gridColor1;
		private ppsGrid.GridColor gridColor2;
		private ppsGrid.GridColor gridColor3;
		private ppsGrid.GridColor gridColor4;
		private ppsGrid.GridColor gridColor5;
		private ppsGrid.GridColor gridColor6;
		private ppsGrid.GridColor gridColor7;
		private ppsGrid.GridColor gridColor8;
		private System.ComponentModel.IContainer components = null;

		public frmOutlineCol(){
			InitializeComponent();
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing ){
			if(disposing)
				if (components != null) 
					components.Dispose();
			base.Dispose( disposing );
		}

		
		public void Init(){
			GridCol			col;
			Random			rnd=new Random();
			int					x,nameIdx;
			byte[]			bff=new byte[16];
			Font				fnt=grid.Font;
			DateTime		dte=new DateTime(DateTime.Today.Year,1,1);

			try{
//			grid.BeginUpdate();

				grid.AddRows(1);
				//grid.Scrollbar=eScrollbar.Both;
				grid.OutlineDashStyle=eDashStyle.DashDotDot;
				grid.Rows[0].FormatString="0000";
				grid.Rows[1].OutlineMode=true;
				grid.Rows[1].Height=92;

				grid.Cells[0,"rowName"].Value="Name";
				grid.Cells[0,"rowStadt"].Value="Stadt";
				grid.Cells[0,"rowData"].Value="Daten";
				grid.Cells[0,"rowLevel"].Value="Level";
				grid.Cells[0,"rowParent"].Value="Parent";
				grid.Cells[0,"rowFirstChild"].Value="First-Child";
				grid.Cells[0,"rowLastChild"].Value="Last-Child";
				grid.Cells[0,"rowPrevCol"].Value="Prev-Col";
				grid.Cells[0,"rowNextCol"].Value="Next-Col";
				grid.Cells[0,"rowPathName"].Value="Path Name";
				grid.Cells[0,"rowPathStadt"].Value="Path Stadt";

				grid.AddCols(10);
				grid.Cols[1].Fixed=grid.Cols[2].Fixed=true;
				grid.Cols[3].BackColorCell=Color.FromKnownColor(KnownColor.Gold);

				for(int i=0;i<8;i++){
					x=255-(i*8);
					grid.LevelColors.Add(new GridColor(Color.FromArgb(x,x,x)));
					grid.LevelColors[i].ForeColorCell=Color.FromArgb(i*16,i*16,i*16);
				}


				grid.ResetCellPadding();
				grid.BackColorApp=Color.Yellow;
				x=grid.FixedColCount;
				while(x<grid.Cols.Count){
					col=grid.Cols[x];
					if(rnd.Next(7)>2+col.Outline.Level)
						col.Outline.AddChilds(rnd.Next(4-col.Outline.Level)+1);

					for(int y=1;y<3;y++)
						grid.Cells[x,y].Value=RandomString(rnd,2,rnd.Next(12)+2);


					switch(rnd.Next(5)){
						case 0:
							grid.Cells[x,3].Value=rnd.Next();
							break;
						case 1:
							grid.Cells[x,3].Value=rnd.NextDouble()*1000;
							break;
						case 2:
							grid.Cells[x,3].Value=dte.AddDays(rnd.Next(366));
							break;
						case 3:
						case 4:
							grid.Cells[x,3].Value=RandomString(rnd,2,rnd.Next(10)+2);
							break;
					}
					x++;
				}

				
				for(x=grid.FixedColCount;x<grid.Cols.Count;x++){
					col=grid.Cols[x];
					grid.Cells[x,"rowLevel"].Value=col.Outline.Level;
					nameIdx=grid.Rows["rowName"].Row;

					if(col.Outline.Parent!=null)
						grid.Cells[x,"rowParent"].Value=grid.Cells[col.Outline.Parent.Column,nameIdx].Value;
					if(col.Outline.FirstChild!=null)
						grid.Cells[x,"rowFirstChild"].Value=grid.Cells[col.Outline.FirstChild.Column,nameIdx].Value;
					if(col.Outline.LastChild!=null)
						grid.Cells[x,"rowLastChild"].Value=grid.Cells[col.Outline.LastChild.Column,nameIdx].Value;
					if(col.Outline.PrevColumn!=null)
						grid.Cells[x,"rowPrevCol"].Value=grid.Cells[col.Outline.PrevColumn.Column,nameIdx].Value;
					if(col.Outline.NextColumn!=null)
						grid.Cells[x,"rowNextCol"].Value=grid.Cells[col.Outline.NextColumn.Column,nameIdx].Value;
					grid.Cells[x,"rowPathName"].Value=col.Outline.FullPath(1,".");
					grid.Cells[x,"rowPathStadt"].Value=col.Outline.FullPath(2,".");
				}
			}

			catch(Exception  ex){
				MessageBox.Show(ex.StackTrace);
			}
			finally{
//			grid.EndUpdate();
			}
		}

		private string RandomString(Random rnd,int min,int max){
			int			cnt=rnd.Next(min,max);
			byte[]	bff=new byte[max];

			for(int i=0;i<cnt;i++)
				bff[i]=(byte)rnd.Next(97,97+26);
			return(Encoding.ASCII.GetString(bff,0,cnt));
		}

		#region Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(frmOutlineCol));
			this.labHitTest = new System.Windows.Forms.Label();
			this.txtHitTest = new System.Windows.Forms.TextBox();
			this.grid = new ppsGrid.Grid();
			this.colLeft = new ppsGrid.GridCol();
			this.gridColor1 = new ppsGrid.GridColor();
			this.gridColor2 = new ppsGrid.GridColor();
			this.gridColor3 = new ppsGrid.GridColor();
			this.gridColor4 = new ppsGrid.GridColor();
			this.gridColor5 = new ppsGrid.GridColor();
			this.gridColor6 = new ppsGrid.GridColor();
			this.gridColor7 = new ppsGrid.GridColor();
			this.gridColor8 = new ppsGrid.GridColor();
			this.rowNo = new ppsGrid.GridRow();
			this.rowName = new ppsGrid.GridRow();
			this.rowStadt = new ppsGrid.GridRow();
			this.rowData = new ppsGrid.GridRow();
			this.rowLevel = new ppsGrid.GridRow();
			this.rowParent = new ppsGrid.GridRow();
			this.rowFirstChild = new ppsGrid.GridRow();
			this.rowLastChild = new ppsGrid.GridRow();
			this.rowPrevCol = new ppsGrid.GridRow();
			this.rowNextCol = new ppsGrid.GridRow();
			this.rowPathName = new ppsGrid.GridRow();
			this.rowPathStadt = new ppsGrid.GridRow();
			this.SuspendLayout();
			// 
			// labHitTest
			// 
			this.labHitTest.Anchor = (System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left);
			this.labHitTest.Location = new System.Drawing.Point(8, 288);
			this.labHitTest.Name = "labHitTest";
			this.labHitTest.Size = new System.Drawing.Size(80, 16);
			this.labHitTest.TabIndex = 4;
			this.labHitTest.Text = "GridHitTestInfo";
			// 
			// txtHitTest
			// 
			this.txtHitTest.Anchor = ((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right);
			this.txtHitTest.Location = new System.Drawing.Point(92, 284);
			this.txtHitTest.Name = "txtHitTest";
			this.txtHitTest.Size = new System.Drawing.Size(360, 21);
			this.txtHitTest.TabIndex = 5;
			this.txtHitTest.Text = "";
			// 
			// grid
			// 
			this.grid.BackColorCell = System.Drawing.Color.FromArgb(((System.Byte)(255)), ((System.Byte)(255)), ((System.Byte)(192)));
			this.grid.BackColorFixedGradient = System.Drawing.Color.RosyBrown;
			this.grid.BackColorRowAlternate = System.Drawing.Color.FromArgb(((System.Byte)(128)), ((System.Byte)(255)), ((System.Byte)(128)));
			this.grid.BottomRow = this.rowPathStadt;
			this.grid.CellHomeVisible = true;
			this.grid.Cols.AddRange(new object[] {
																						 this.colLeft});
			this.grid.ControlEditInfo.Control = null;
			this.grid.Dock = System.Windows.Forms.DockStyle.Fill;
			this.grid.FixedColType = ((ppsGrid.eFixedColType.Sortable | ppsGrid.eFixedColType.Moveable) 
				| ppsGrid.eFixedColType.Sizeable);
			this.grid.FixedRowType = (ppsGrid.eFixedRowType.Moveable | ppsGrid.eFixedRowType.Sizeable);
			this.grid.LeftCol = this.colLeft;
			this.grid.LevelColors.AddRange(new object[] {
																										this.gridColor1,
																										this.gridColor2,
																										this.gridColor3,
																										this.gridColor4,
																										this.gridColor5,
																										this.gridColor6,
																										this.gridColor7,
																										this.gridColor8});
			this.grid.Location = new System.Drawing.Point(4, 4);
			this.grid.Name = "grid";
			this.grid.RightCol = this.colLeft;
			this.grid.Rows.AddRange(new object[] {
																						 this.rowNo,
																						 this.rowName,
																						 this.rowStadt,
																						 this.rowData,
																						 this.rowLevel,
																						 this.rowParent,
																						 this.rowFirstChild,
																						 this.rowLastChild,
																						 this.rowPrevCol,
																						 this.rowNextCol,
																						 this.rowPathName,
																						 this.rowPathStadt});
			this.grid.Scrollbar = ppsGrid.eScrollbar.Both;
			this.grid.SelectionMode = ppsGrid.eSelectionMode.MultipleEx;
			this.grid.SelectionType = ppsGrid.eSelectionType.Free;
			this.grid.Size = new System.Drawing.Size(448, 277);
			this.grid.TabIndex = 7;
			this.grid.TopRow = this.rowName;
			// 
			// colLeft
			// 
			this.colLeft.Fixed = true;
			this.colLeft.FixedGradientMode = ppsGrid.eGradientMode.Vertical;
			this.colLeft.Name = "colLeft";
			// 
			// gridColor1
			// 
			this.gridColor1.BackColorCell = System.Drawing.Color.White;
			// 
			// gridColor2
			// 
			this.gridColor2.BackColorCell = System.Drawing.Color.WhiteSmoke;
			// 
			// gridColor3
			// 
			this.gridColor3.BackColorCell = System.Drawing.Color.Gainsboro;
			// 
			// gridColor4
			// 
			this.gridColor4.BackColorCell = System.Drawing.Color.LightGray;
			// 
			// gridColor5
			// 
			this.gridColor5.BackColorCell = System.Drawing.Color.Silver;
			// 
			// gridColor6
			// 
			this.gridColor6.BackColorCell = System.Drawing.Color.DarkGray;
			// 
			// gridColor7
			// 
			this.gridColor7.BackColorCell = System.Drawing.Color.Gray;
			// 
			// gridColor8
			// 
			this.gridColor8.BackColorCell = System.Drawing.Color.DimGray;
			// 
			// rowNo
			// 
			this.rowNo.Fixed = true;
			this.rowNo.FixedGradientMode = ppsGrid.eGradientMode.Vertical;
			this.rowNo.Name = "rowNo";
			// 
			// rowName
			// 
			this.rowName.Name = "rowName";
			// 
			// rowStadt
			// 
			this.rowStadt.Name = "rowStadt";
			// 
			// rowData
			// 
			this.rowData.Name = "rowData";
			// 
			// rowLevel
			// 
			this.rowLevel.Name = "rowLevel";
			// 
			// rowParent
			// 
			this.rowParent.Name = "rowParent";
			// 
			// rowFirstChild
			// 
			this.rowFirstChild.Name = "rowFirstChild";
			// 
			// rowLastChild
			// 
			this.rowLastChild.Name = "rowLastChild";
			// 
			// rowPrevCol
			// 
			this.rowPrevCol.Name = "rowPrevCol";
			// 
			// rowNextCol
			// 
			this.rowNextCol.Name = "rowNextCol";
			// 
			// rowPathName
			// 
			this.rowPathName.Name = "rowPathName";
			// 
			// rowPathStadt
			// 
			this.rowPathStadt.Name = "rowPathStadt";
			// 
			// frmOutlineCol
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 14);
			this.ClientSize = new System.Drawing.Size(456, 285);
			this.Controls.AddRange(new System.Windows.Forms.Control[] {
																																	this.grid,
																																	this.txtHitTest,
																																	this.labHitTest});
			this.DockPadding.All = 4;
			this.Font = new System.Drawing.Font("Tahoma", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.Name = "frmOutlineCol";
			this.Text = "Outline";
			this.ResumeLayout(false);

		}
		#endregion
	}
}

