using System;
using System.Collections;
using System.ComponentModel;
using System.Drawing;
using System.Drawing.Text;

using System.Windows.Forms;
using ppsGrid;

namespace grdDemo.frm{
	public class frmPicAlign:System.Windows.Forms.Form{
		private ppsGrid.Grid grid;
		private ppsGrid.GridRow rowDown;
		private ppsGrid.GridRow rowTitle;
		private ppsGrid.GridCol colNo;
		private ppsGrid.GridCol colLeft;
		private ppsGrid.GridRow rowCenter;
		private ppsGrid.GridCol colRight;
		private ppsGrid.GridRow rowUp;
		private System.Windows.Forms.PictureBox picBox;
		private ppsGrid.GridCol colCenter;
		private System.ComponentModel.IContainer components = null;

		public frmPicAlign(){
			InitializeComponent();
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing ){
			if(disposing)
				if (components != null) 
					components.Dispose();
			base.Dispose( disposing );
		}

		
		public void Init(){
			Image	img=picBox.Image;
			
			for(int r=grid.FixedRowCount;r<grid.Rows.Count;r++)
				grid.Rows[r].Height=img.Height+24;
			for(int c=grid.FixedColCount;c<grid.Cols.Count;c++)
				grid.Cols[c].Width=img.Width+24;

			for(int c=grid.FixedColCount;c<grid.Cols.Count;c++)
				for(int r=grid.FixedRowCount;r<grid.Rows.Count;r++){
					grid.Cells[c,r].Image=new Bitmap(img);
					grid.Cells[c,r].Value=c.ToString()+"."+r.ToString();
				}

			foreach(GridRow r in grid.Rows){
				r["colLeft"].ImageAlignHorz=eContentAlign.Near;
				r["colCenter"].ImageAlignHorz=eContentAlign.Center;
				r["colRight"].ImageAlignHorz=eContentAlign.Far;
			}
			foreach(GridCol c in grid.Cols){
				c["rowUp"].ImageAlignVert=eContentAlign.Near;
				c["rowCenter"].ImageAlignVert=eContentAlign.Center;
				c["rowDown"].ImageAlignVert=eContentAlign.Far;
			}


//			grid.Cells["colLeft","rowUp"].ImageAlign=ContentAlignment.TopLeft;
//			grid.Cells["colLeft","rowCenter"].ImageAlign=ContentAlignment.MiddleLeft;
//			grid.Cells["colLeft","rowDown"].ImageAlign=ContentAlignment.BottomLeft;
//			
//			grid.Cells["colCenter","rowUp"].ImageAlign=ContentAlignment.TopCenter;
//			grid.Cells["colCenter","rowCenter"].ImageAlign=ContentAlignment.MiddleCenter;
//			grid.Cells["colCenter","rowDown"].ImageAlign=ContentAlignment.BottomCenter;
//			
//			grid.Cells["colRight","rowUp"].ImageAlign=ContentAlignment.TopRight;
//			grid.Cells["colRight","rowCenter"].ImageAlign=ContentAlignment.MiddleRight;
//			grid.Cells["colRight","rowDown"].ImageAlign=ContentAlignment.BottomRight;
		}

		#region Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent() {
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(frmPicAlign));
			this.colCenter = new ppsGrid.GridCol();
			this.picBox = new System.Windows.Forms.PictureBox();
			this.rowUp = new ppsGrid.GridRow();
			this.colRight = new ppsGrid.GridCol();
			this.rowCenter = new ppsGrid.GridRow();
			this.colLeft = new ppsGrid.GridCol();
			this.colNo = new ppsGrid.GridCol();
			this.rowTitle = new ppsGrid.GridRow();
			this.rowDown = new ppsGrid.GridRow();
			this.grid = new ppsGrid.Grid();
			this.SuspendLayout();
			// 
			// colCenter
			// 
			this.colCenter.Name = "colCenter";
			// 
			// picBox
			// 
			this.picBox.Image = ((System.Drawing.Image)(resources.GetObject("picBox.Image")));
			this.picBox.Location = new System.Drawing.Point(296, 200);
			this.picBox.Name = "picBox";
			this.picBox.Size = new System.Drawing.Size(128, 128);
			this.picBox.SizeMode = System.Windows.Forms.PictureBoxSizeMode.AutoSize;
			this.picBox.TabIndex = 1;
			this.picBox.TabStop = false;
			this.picBox.Visible = false;
			// 
			// rowUp
			// 
			this.rowUp.Name = "rowUp";
			// 
			// colRight
			// 
			this.colRight.Name = "colRight";
			// 
			// rowCenter
			// 
			this.rowCenter.Name = "rowCenter";
			// 
			// colLeft
			// 
			this.colLeft.Name = "colLeft";
			// 
			// colNo
			// 
			this.colNo.Fixed = true;
			this.colNo.Name = "colNo";
			// 
			// rowTitle
			// 
			this.rowTitle.Fixed = true;
			this.rowTitle.Name = "rowTitle";
			// 
			// rowDown
			// 
			this.rowDown.Name = "rowDown";
			// 
			// grid
			// 
			this.grid.CellHomeVisible = true;
			this.grid.CellPadding.All = 8;
			this.grid.Cols.AddRange(new object[] {
						this.colNo,
						this.colLeft,
						this.colCenter,
						this.colRight});
			this.grid.Dock = System.Windows.Forms.DockStyle.Fill;
			this.grid.FixedRowType = ((ppsGrid.eFixedRowType)((ppsGrid.eFixedRowType.Moveable | ppsGrid.eFixedRowType.Sizeable)));
			this.grid.Location = new System.Drawing.Point(0, 0);
			this.grid.MaxColWidth = 180;
			this.grid.MaxRowHeight = 180;
			this.grid.MinColWidth = 8;
			this.grid.MinRowHeight = 8;
			this.grid.Name = "grid";
			this.grid.Rows.AddRange(new object[] {
						this.rowTitle,
						this.rowUp,
						this.rowCenter,
						this.rowDown});
			this.grid.Scrollbar = ppsGrid.eScrollbar.Both;
			this.grid.ScrollbarVisible = ppsGrid.eScrollbarVisible.Required;
			this.grid.SelectionType = ppsGrid.eSelectionType.None;
			this.grid.Size = new System.Drawing.Size(464, 365);
			this.grid.StringTrimming = System.Drawing.StringTrimming.None;
			this.grid.TabIndex = 0;
			// 
			// frmPicAlign
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(464, 365);
			this.Controls.Add(this.picBox);
			this.Controls.Add(this.grid);
			this.Name = "frmPicAlign";
			this.Text = "Picture-Alignment";
			this.ResumeLayout(false);
		}
		#endregion

	}
}

