using System;
using System.Collections;
using System.IO;
using System.ComponentModel;
using System.Drawing;
using System.Drawing.Text;

using System.Windows.Forms;
using ppsGrid;

namespace grdDemo.frm{
	public class frmPics:System.Windows.Forms.Form{
		private Grid grid;
		private ppsGrid.GridCol colNo;
		private ppsGrid.GridCol colName;
		private ppsGrid.GridCol colSize;
		private ppsGrid.GridCol colBild;
		private ppsGrid.GridRow rowTitle;
		private System.ComponentModel.IContainer components = null;

		public frmPics(){
			InitializeComponent();
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing ){
			if(disposing)
				if (components != null) 
					components.Dispose();
			base.Dispose( disposing );
		}

		
		public void Init(){
			string		pth;
			string[]	files;
			try{
				pth=Application.StartupPath+@"\pics";
				files=Directory.GetFiles(pth);
			}
			catch{
				MessageBox.Show((IWin32Window)null,"Im Verzeichnis der exe-Datei ein Verzeichnis 'pics' erstellen und mit Bildern fllen");
				return;
			}
			GridRow			row;
			GridCell		cell;
			int					lastRow;
			Random			rnd=new Random();
			Graphics		gfx=CreateGraphics();
			Array				algn=Enum.GetValues(typeof(eContentAlign));

			grid.Cells["colName",0].Value="Name";
			grid.Cells["colSize",0].Value="Gre";
			grid.Cells["colBild",0].Value="Bild";
			grid.Cols["colBild"].CellPadding.All=0;

			try{
				foreach(string nm in files){
					if(nm.EndsWith("jpg")){
						Bitmap	bm=new Bitmap(nm);
						int			wdth;
						string	s,cr=System.Environment.NewLine;

						s= "Wdth :"+bm.PhysicalDimension.Width.ToString()+cr;
						s+="Hght :"+bm.PhysicalDimension.Height.ToString()+cr;
						s+="DpiX :"+bm.HorizontalResolution.ToString()+cr;
						s+="DpiY :"+bm.VerticalResolution.ToString();

						grid.AddRows(1);
						lastRow=grid.Rows.Count-1;
						row=grid.Rows[lastRow];
						grid.Cells["colName",lastRow].Value=nm;
						grid.Cells["colSize",lastRow].Value=s;
						grid.Cells["colSize",lastRow].Font=new Font(Font.Name,9);

						cell=grid.Cells["colBild",lastRow];
						cell.Image=bm;

						row.Height=	(int)(gfx.DpiY*bm.Height/bm.VerticalResolution)+36;
						wdth= (int)(gfx.DpiX*bm.Width/bm.HorizontalResolution);
						if(grid.Cols["colBild"].Width<wdth)			
							grid.Cols["colBild"].Width=wdth;

						cell.ImageAlignHorz=(eContentAlign)algn.GetValue(rnd.Next(3));
						cell.ImageAlignVert=(eContentAlign)algn.GetValue(rnd.Next(3));
					}
				}
			}
			catch{
			}
			finally{
				gfx.Dispose();
			}
		}

		#region Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.grid = new ppsGrid.Grid();
			this.colNo = new ppsGrid.GridCol();
			this.colSize = new ppsGrid.GridCol();
			this.colName = new ppsGrid.GridCol();
			this.colBild = new ppsGrid.GridCol();
			this.rowTitle = new ppsGrid.GridRow();
			this.SuspendLayout();
			// 
			// grid
			// 
			this.grid.BackColorCell = System.Drawing.Color.FromArgb(((System.Byte)(255)), ((System.Byte)(255)), ((System.Byte)(192)));
			this.grid.BackColorCellGradient = System.Drawing.Color.FromArgb(((System.Byte)(64)), ((System.Byte)(64)), ((System.Byte)(64)));
			this.grid.BackColorFixed = System.Drawing.Color.FromArgb(((System.Byte)(192)), ((System.Byte)(192)), ((System.Byte)(255)));
			this.grid.BackColorFixedGradient = System.Drawing.Color.Gray;
			this.grid.CellGradientMode = ppsGrid.eGradientMode.ForwardDiagonal;
			this.grid.Cols.AddRange(new object[] {
																						 this.colNo,
																						 this.colSize,
																						 this.colName,
																						 this.colBild});
			this.grid.Dock = System.Windows.Forms.DockStyle.Fill;
			this.grid.FixedColType = ((ppsGrid.eFixedColType.Sortable | ppsGrid.eFixedColType.Moveable) 
				| ppsGrid.eFixedColType.Sizeable);
			this.grid.FixedRowType = (ppsGrid.eFixedRowType.Moveable | ppsGrid.eFixedRowType.Sizeable);
			this.grid.ForeColorFixed = System.Drawing.SystemColors.WindowText;
			this.grid.Name = "grid";
			this.grid.Rows.AddRange(new object[] {
																						 this.rowTitle});
			this.grid.Scrollbar = ppsGrid.eScrollbar.Both;
			this.grid.SelectionType = ppsGrid.eSelectionType.None;
			this.grid.Size = new System.Drawing.Size(289, 141);
			this.grid.TabIndex = 1;
			// 
			// colNo
			// 
			this.colNo.AutoNumber = true;
			this.colNo.Fixed = true;
			this.colNo.FixedGradientMode = ppsGrid.eGradientMode.Horizontal;
			this.colNo.Name = "colNo";
			this.colNo.Width = 25;
			// 
			// colSize
			// 
			this.colSize.Name = "colSize";
			this.colSize.Width = 40;
			// 
			// colName
			// 
			this.colName.Name = "colName";
			// 
			// colBild
			// 
			this.colBild.Name = "colBild";
			this.colBild.Width = 124;
			this.colBild.WidthPercent = 100;
			this.colBild.WidthType = ppsGrid.eWidthType.Percent;
			// 
			// rowTitle
			// 
			this.rowTitle.Fixed = true;
			this.rowTitle.Name = "rowTitle";
			// 
			// frmPics
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(289, 141);
			this.Controls.AddRange(new System.Windows.Forms.Control[] {
																																	this.grid});
			this.Name = "frmPics";
			this.Text = "Picture";
			this.ResumeLayout(false);

		}
		#endregion
	}
}

