using System;
using System.Collections;
using System.ComponentModel;
using System.Drawing;
using System.Drawing.Text;
using System.Text;

using System.Diagnostics;
using System.Windows.Forms;
using ppsGrid;

namespace grdDemo.frm{
	public class frmSort:System.Windows.Forms.Form{
		private ppsGrid.Grid grid;
		private ppsGrid.GridCol colNo;
		private ppsGrid.GridCol colStrasse;
		private ppsGrid.GridCol colDatum;
		private ppsGrid.GridCol colEinkommen;
		private ppsGrid.GridRow rowTitle;
		private ppsGrid.GridRow rowTitle2;
		private ppsGrid.GridCol colName;
		private ppsGrid.GridCol colHausNr;
		private System.ComponentModel.IContainer components = null;

		public frmSort(){
			InitializeComponent();
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing ){
			if(disposing)
				if (components != null) 
					components.Dispose();
			base.Dispose( disposing );
		}

		
		public void Init(){
			GridRow		row;
			Random		rnd=new Random();
			DateTime	dte;

			grid.AddRows(100);																					// 100 zeilen (+ 2 fixierte aus designMode)
			
			row=grid.Rows[0];																						// erste (fixed) zeile
			grid.Cells["colName",0].Value="Name";						// berschriften..
			grid.Cells["colStrasse",0].Value="Strae";
			grid.Cells["colHausNr",0].Value="Hausnr.";
			grid.Cells["colDatum",0].Value="Datum";
			grid.Cells["colEinkommen",0].Value="Einkommen";

			row=grid.Rows[1];																		// zweite (fixierte) zeile
			grid.Cells["colName",1].Value="string";												// datentypen..
			grid.Cells["colStrasse",1].Value="string";
			grid.Cells["colHausNr",1].Value="int";
			grid.Cells["colDatum",1].Value="Datum";
			grid.Cells["colEinkommen",1].Value="float";


			grid.Cols["colDatum"].FormatString="dd.MM.yyyy";				// format spalte datum
			grid.Cols["colEinkommen"].FormatString="C";							// format spalte einkommen (whrung)

			grid.Rows[0].StringAlignHorz=grid.Rows[1].StringAlignHorz=eContentAlign.Center;
			grid.Rows[0].StringAlignVert=grid.Rows[1].StringAlignVert=eContentAlign.Center;



			for(int i=grid.FixedRowCount;i<grid.Rows.Count;i++){		// alle (nonFixed) zeilen
				grid.Cells[1,i].Value=RandomString(rnd,8);								// ..name (string)
				grid.Cells[2,i].Value=RandomString(rnd,12);							// ..strae (string)
				grid.Cells[3,i].Value=rnd.Next(99)+1;										// ..hausnr. (byte, int, long)

				dte=new DateTime(DateTime.Today.Year,1,1);
				grid.Cells[4,i].Value=dte.AddDays(rnd.Next(365));				// ..datum aus aktuellen jahr (DateTime)
				grid.Cells[5,i].Value=rnd.NextDouble()*1000+1000;				// eikommen (float/double)
			}
		}

		private string RandomString(Random rnd,int max){
			int			cnt=rnd.Next(max);
			byte[]	bff=new byte[max];

			for(int i=0;i<cnt;i++)
				bff[i]=(byte)rnd.Next(97,97+26);
			return(Encoding.ASCII.GetString(bff,0,cnt));
		}

		#region Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(frmSort));
			this.grid = new ppsGrid.Grid();
			this.colNo = new ppsGrid.GridCol();
			this.colName = new ppsGrid.GridCol();
			this.colStrasse = new ppsGrid.GridCol();
			this.colHausNr = new ppsGrid.GridCol();
			this.colDatum = new ppsGrid.GridCol();
			this.colEinkommen = new ppsGrid.GridCol();
			this.rowTitle = new ppsGrid.GridRow();
			this.rowTitle2 = new ppsGrid.GridRow();
			this.SuspendLayout();
			// 
			// grid
			// 
			this.grid.BackColorCell = System.Drawing.Color.White;
			this.grid.BackColorCellGradient = System.Drawing.Color.FromArgb(((System.Byte)(255)), ((System.Byte)(255)), ((System.Byte)(192)));
			this.grid.BackColorColAlternate = System.Drawing.Color.FromArgb(((System.Byte)(255)), ((System.Byte)(255)), ((System.Byte)(128)));
			this.grid.BackColorFixed = System.Drawing.Color.FromArgb(((System.Byte)(192)), ((System.Byte)(192)), ((System.Byte)(255)));
			this.grid.BackColorFixedGradient = System.Drawing.Color.FromArgb(((System.Byte)(255)), ((System.Byte)(224)), ((System.Byte)(192)));
			this.grid.BackColorRowAlternate = System.Drawing.Color.FromArgb(((System.Byte)(255)), ((System.Byte)(224)), ((System.Byte)(192)));
			this.grid.Cols.AddRange(new object[] {
																						 this.colNo,
																						 this.colName,
																						 this.colStrasse,
																						 this.colHausNr,
																						 this.colDatum,
																						 this.colEinkommen});
			this.grid.Cursor = System.Windows.Forms.Cursors.Default;
			this.grid.Dock = System.Windows.Forms.DockStyle.Fill;
			this.grid.FixedColType = ((ppsGrid.eFixedColType.Sortable | ppsGrid.eFixedColType.Moveable) 
				| ppsGrid.eFixedColType.Sizeable);
			this.grid.FixedRowType = (ppsGrid.eFixedRowType.Moveable | ppsGrid.eFixedRowType.Sizeable);
			this.grid.Font = new System.Drawing.Font("Tahoma", 9F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.grid.ForeColorFixed = System.Drawing.SystemColors.WindowText;
			this.grid.Location = new System.Drawing.Point(1, 1);
			this.grid.Name = "grid";
			this.grid.Rows.AddRange(new object[] {
																						 this.rowTitle,
																						 this.rowTitle2});
			this.grid.SelectionType = ppsGrid.eSelectionType.Free;
			this.grid.Size = new System.Drawing.Size(606, 223);
			this.grid.TabIndex = 1;
			this.grid.BeforeColumnSort += new ppsGrid.OnBeforeColumnSort(this.grid_BeforeColumnSort);
			this.grid.CellDoubleClick += new ppsGrid.OnCellDoubleClick(this.grid_CellDoubleClick);
			this.grid.AfterColumnSort += new ppsGrid.OnAfterColumnSort(this.grid_AfterColumnSort);
			this.grid.CellMouseLeave += new ppsGrid.OnCellMouseLeave(this.grid_CellMouseLeave);
			this.grid.CellClick += new ppsGrid.OnCellClick(this.grid_CellClick);
			this.grid.CellMouseHover += new ppsGrid.OnCellMouseHover(this.grid_CellMouseHover);
			this.grid.CellMouseEnter += new ppsGrid.OnCellMouseEnter(this.grid_CellMouseEnter);
			// 
			// colNo
			// 
			this.colNo.AutoNumber = true;
			this.colNo.Fixed = true;
			this.colNo.Name = "colNo";
			this.colNo.Width = 25;
			// 
			// colName
			// 
			this.colName.Name = "colName";
			this.colName.WidthPercent = 10;
			this.colName.WidthType = ppsGrid.eWidthType.Percent;
			// 
			// colStrasse
			// 
			this.colStrasse.Name = "colStrasse";
			this.colStrasse.WidthPercent = 10;
			this.colStrasse.WidthType = ppsGrid.eWidthType.Percent;
			// 
			// colHausNr
			// 
			this.colHausNr.Name = "colHausNr";
			this.colHausNr.WidthPercent = 10;
			this.colHausNr.WidthType = ppsGrid.eWidthType.Percent;
			// 
			// colDatum
			// 
			this.colDatum.Name = "colDatum";
			this.colDatum.WidthPercent = 10;
			this.colDatum.WidthType = ppsGrid.eWidthType.Percent;
			// 
			// colEinkommen
			// 
			this.colEinkommen.Name = "colEinkommen";
			this.colEinkommen.WidthPercent = 10;
			this.colEinkommen.WidthType = ppsGrid.eWidthType.Percent;
			// 
			// rowTitle
			// 
			this.rowTitle.Fixed = true;
			this.rowTitle.Font = new System.Drawing.Font("Tahoma", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.rowTitle.Height = 20;
			this.rowTitle.Name = "rowTitle";
			// 
			// rowTitle2
			// 
			this.rowTitle2.Fixed = true;
			this.rowTitle2.Font = new System.Drawing.Font("Tahoma", 9.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.rowTitle2.Height = 20;
			this.rowTitle2.Name = "rowTitle2";
			// 
			// frmSort
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(608, 225);
			this.Controls.AddRange(new System.Windows.Forms.Control[] {
																																	this.grid});
			this.DockPadding.All = 1;
			this.Name = "frmSort";
			this.Text = "Sort";
			this.ResumeLayout(false);

		}
		#endregion

		private void grid_AfterColumnSort(object sender, ppsGrid.AfterColumnSortEventArgs e) {
			Debug.WriteLine("AfterColSort:"+e.Column.ToString()+" "+e.Direction.ToString());
		}

		private void grid_BeforeColumnSort(object sender, ppsGrid.BeforeColumnSortEventArgs e) {
			Debug.WriteLine("BeforeColSort:"+e.Column.ToString()+" "+e.Direction.ToString());

			if(grid.Cols[e.Column].Name=="Name"){
				DialogResult	btn;
				btn=MessageBox.Show(this,"Spalte Name sortieren ???","sort...",MessageBoxButtons.YesNo);
				e.Cancel=(btn==DialogResult.No);
			}
		}

		private void grid_CellClick(object sender, ppsGrid.CellClickEventArgs e) {
			Debug.WriteLine("CellClick:"+e.Column+" "+e.Row);
		}

		private void grid_CellDoubleClick(object sender, ppsGrid.CellClickEventArgs e) {
			Debug.WriteLine("CellDblClick:"+e.Column+" "+e.Row);
		}

		private void grid_CellMouseEnter(object sender, ppsGrid.CellMouseEventArgs e) {
			Debug.WriteLine("CellMouseEnter:"+e.Column+" "+e.Row);
		}

		private void grid_CellMouseHover(object sender, ppsGrid.CellMouseEventArgs e) {
			Debug.WriteLine("CellMouseHover:"+e.Column+" "+e.Row);
		}

		private void grid_CellMouseLeave(object sender, ppsGrid.CellMouseEventArgs e) {
			Debug.WriteLine("CellMouseLeave:"+e.Column+" "+e.Row);
		}
	}
}

