using System;
using System.Collections;
using System.ComponentModel;
using System.Drawing;
using System.Diagnostics;

using System.Windows.Forms;
using ppsGrid;

namespace grdDemo.frm{
	public class frmSweeper:System.Windows.Forms.Form{
		private System.ComponentModel.IContainer components;
		private ppsGrid.Grid grid;
		private System.Windows.Forms.Label labMines;
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.Label label2;
		private System.Windows.Forms.Timer tmeTime;
		private System.Windows.Forms.ToolTip tipToolTip;
		private System.Windows.Forms.Button btnSmilie;
		private System.Windows.Forms.Label labTime;
		private System.Windows.Forms.ImageList imgList;
		static int bm_Empty=0,bm_Defused=1,bm_nomine=2,bm_mine=3,
			bm_bad=10,bm_good=11,bm_oha=12;														// index der bilder in imgListt

		int vDff=6;																									// schwierigkeitsgrad 3=sehr schwierig, 4,schwierig, 
																																// 6=mittel, 8=leicht, 12=sehrleicht
		int	vRowCount=16,vColCount=24;															// zeilen, spalten
		int vMineCount=0;																						// anzahl der minen


		public frmSweeper(){
			InitializeComponent();
		}
		protected override void Dispose( bool disposing ){
			if(disposing)
				if (components != null) 
					components.Dispose();
			base.Dispose( disposing );

			grid.BackColorCell=Color.FromKnownColor(KnownColor.ActiveBorder);
		}

		// info's in Cell-Tag:

		// c  = closed							- noch nicht geffnet
		// m  = mine								- mine
		// e  = empty								- leer
		// b  = by (mine [1-9])			- geffnet neben Mine
		// .d = defused							- entschrft


		// init game
		public void Init(){
			this.Size=new Size(vColCount*16+20,vRowCount*16+60);		// form gre
			vMineCount=vColCount*vRowCount/vDff;										// anzahl der minen

			grid.AddCols(vColCount);																// zellen..
			grid.AddRows(vRowCount);																// ..erstellen
			grid.CellPadding.All=0;

			for(int x=0;x<grid.Cols.Count;x++)											// spaltenbreite
				grid.Cols[x].Width=16;
			for(int y=0;y<grid.Rows.Count;y++)											// zeilenhhe
				grid.Rows[y].Height=16;
			
			grid.Width=vColCount*16+4;															// gre vom grid
			grid.Height=vRowCount*16+4;

			CreateMines();																					// minen erzeugen:-)
		}

		// ziel des spiels: die minen finden
		public void CreateMines(){
			Bitmap		bm=new Bitmap(imgList.Images[bm_Empty]);			// image leere zelle
			Random		rnd=new Random();
			int				i,rw,cl;

			for(int x=0;x<grid.Cols.Count;x++)											// alle..
				for(int y=0;y<grid.Rows.Count;y++){										// ..zellen
					grid[x,y].Image=bm;																	// ....image..
					grid[x,y].Tag="c";																	// ....und info
				}

			for(i=0;i<vMineCount;i++){															// alle minen
				do{
					rw=rnd.Next(vRowCount);															// ..per zufall auf..
					cl=rnd.Next(vColCount);															// ..gesamten spielfeld verteilen
				}while(IsFieldMine(cl,rw));														// ist schon mine? noch mal
				
				grid[cl,rw].Tag="m";																	// feld als mine kennzeichnen
			}

			labTime.Text="0";																				// zeit
			labMines.Text=vMineCount.ToString();										// minen
			btnSmilie.Image=imgList.Images[bm_good];								// smilie lchelt (noch)..

			tmeTime.Interval=1000;																	// zeit zhlt..
			tmeTime.Start();																				// ..ab jetzt
		}

		public void Timer(object sender, System.EventArgs e){
			int	tm=int.Parse(labTime.Text)+1;												// 1 sekunde mehr
			labTime.Text=tm.ToString();															// ...anzeigen
		}

		// alle mausTasten - drcken
		public void onMouseDown(object sender, MouseEventArgs e){
			btnSmilie.Image=imgList.Images[bm_oha];									// smilie mit offenen mund

			if(e.Button==MouseButtons.Right)												// rechte mouseTaste ?
				DefuseMine(e.X/16,e.Y/16);														// ..mine entschrfen
			else
				onClick(sender,e);																		// ..linksClick...
		}
		// alle mausTasten - loslassen
		public void onMouseUp(object sender, MouseEventArgs e){
			btnSmilie.Image=imgList.Images[bm_good];								// smilie lchelt
		}


		// maustaste links
		public void onClick(object sender,MouseEventArgs e){
			int				x,y;
			Bitmap		bm=new Bitmap(imgList.Images[bm_mine]);

			x=e.X/16;																								// ..welche zelle ? 
			y=e.Y/16;

			if(IsFieldMine(x,y)){																		// ..is mine ? (booom)
				tmeTime.Stop();																				// ..zeit anhalten
				btnSmilie.Image=imgList.Images[bm_bad];								// smilie guckt nicht glcklich

				for(y=0;y<vRowCount;y++)                              // alle minen..
					for(x=0;x<vColCount;x++)                            // ..auf gesamten feld
						if(IsFieldMine(x,y))															// ....
							grid[x,y].Image=bm;															// ....anzeigen
			}
			else{																										// ..keine mine (puuuh)
				if(IsFieldDefused(x,y)==false){												// ..mine war nicht entschrft ?
					int cnt=CountMines(x,y);														// ....anzahl minen umzu zhlen
					if(cnt==0)																					// ....null ?
						OpenArea(x,y);																		// ......komplettes feld ffnen
					else if(cnt<7)																			// ....mine umzu ?
						grid[x,y].Image=new Bitmap(imgList.Images[3+cnt]);// ......anzahl anzeigen
				}
			}
		}
		private void btnSmilie_Click(object sender, System.EventArgs e) {
			CreateMines();																					// neues spiel
		}

		public GridCell getField(int x,int y){
			return(grid[x,y]);																			// zelle berechnen (na ja..)
		}

		// anzahl der minen im 8er-Feld zhlen
		public int CountMines(int xPos,int yPos){									// anzahl der minen im 3x3 feld
			int	rslt=0,x,y;

			for(y=0;y<3;y++)																				// feld zhlen..
				for(x=0;x<3;x++)																			// ..im 3er (3x3) feld
					if(x!=1 || y!=1)																		// ....auer ausgangsfeld selbst
						if(IsFieldMine(xPos+x-1,yPos+y-1))								// ......ist mine ?
							rslt++;																					// ........eine mine mehr
			return(rslt);																						// zhler zurck
		}

		// mine entschrfen
		public void DefuseMine(int xPos,int yPos){
			GridCell	cell=getField(xPos,yPos);
			int				cnt;

			cnt=int.Parse(labMines.Text);														// minen gesamt
			if(IsFieldDefused(xPos,yPos)){													// war bereits entschrft ?
				cell.Tag=((string)cell.Tag).Substring(0,1);						// ..info entfernen
				cell.Image=new Bitmap(imgList.Images[bm_Empty]);			// ..zelle ist leer
				labMines.Text=(cnt+1).ToString();											// ..eine mine mehr
			}
			else{																										// nicht entschrft
				cell.Tag+="d";																				// ..info: jetzt entschrft
				cell.Image=new Bitmap(imgList.Images[bm_Defused]);		// ..image anzeigen
				labMines.Text=(cnt-1).ToString();											// ..eine mine weniger
			}
		}

		// mine(nFeld) anzeigen
		public void DisplayMine(int xPos,int yPos){
			int				cnt=CountMines(xPos,yPos);										// anzahl der minen umzu
			GridCell	cell=getField(xPos,yPos);											// feld holen

			if(cnt==0){																							// keine minen umzu ?
				cell.Image=new Bitmap(imgList.Images[bm_nomine]);			// ..image
				cell.Tag="e";																					// ..info
			}
			else if(cnt<7){																					// anzahl von 1-6 (hatte keine lust zum malen :-)
				cell.Image=new Bitmap(imgList.Images[3+cnt]);					// ..bild
				cell.Tag="b";																					// ..info
			}
		}

		// ist feld eine mine ?
		public bool IsFieldMine(int x,int y){
			if(x>=0 && x<vColCount && y>=0 && y<vRowCount)					// xy ok ?
				return((getField(x,y).Tag as string).StartsWith("m"));// ..prfen, ob info "m"ine ist
			else
				return(false);
		}
		// ist feld leer ?
		public bool IsFieldEmpty(int x,int y){
			if(x>=0 && x<vColCount && y>=0 && y<vRowCount)					// xy ok ?
				return((getField(x,y).Tag as string).StartsWith("e"));// ..prfen, ob info "e"mty ist
			else
				return(false);
		}

		// ist feld entschrft
		public bool IsFieldDefused(int x,int y){
			if(x>=0 && x<vColCount && y>=0 && y<vRowCount){					// xy ok ?
				string	s=(getField(x,y).Tag as string);
				if(s.Length>1)
					return(s.Substring(1,1)=="d");											// ..prfen, ob info "d"efused ist
			}
			return(false);
		}

		// ist feld geschlossen ?
		public bool IsFieldClosed(int x,int y){
			if(x>=0 && x<vColCount && y>=0 && y<vRowCount)					// xy ok ?
				return((getField(x,y).Tag as string).StartsWith("c"));// ..prfen, ob info "c"losed ist
			else
				return(false);
		}

		// ein "freies" feld geklickt, komplett ffnen
		public void OpenArea(int xPos,int yPos){
			int i;
			for(i=xPos;i>-1;i--){																		// horizontale nach links
				DisplayMine(i,yPos);																	// ..ffnen
				OpenOrDisplay(i,yPos-1);															// ..recursiv nach oben
				OpenOrDisplay(i,yPos+1);															// ..recursiv nach unten
				if(CountMines(i,yPos)>0)															// ..horizontal ende erreicht ?
					break;																							// ....abbruch
			}

			for(i=xPos;i<vColCount;i++){														// horizontale nach rechts
				DisplayMine(i,yPos);																	// ..sonst wie nach links
				OpenOrDisplay(i,yPos-1);
				OpenOrDisplay(i,yPos+1);
				if(CountMines(i,yPos)>0)
					break;
			}
		}

		// recursiv felder ffenn
		public void OpenOrDisplay(int x,int y){
			if(y>=0 && y<vRowCount)																	// zeile ok ?
				if(IsFieldClosed(x,y)){																// ..feld geschlossen ?
					if(CountMines(x,y)>0)																// ....minen umzu ?
						DisplayMine(x,y);																	// ......letzte ffen
					else																								// ....frei
						OpenArea(x,y);																		// ......recursiv ffnen
				}
		}


		#region Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent() {
			this.components = new System.ComponentModel.Container();
			this.imgList = new System.Windows.Forms.ImageList(this.components);
			this.labTime = new System.Windows.Forms.Label();
			this.btnSmilie = new System.Windows.Forms.Button();
			this.tipToolTip = new System.Windows.Forms.ToolTip(this.components);
			this.tmeTime = new System.Windows.Forms.Timer(this.components);
			this.label2 = new System.Windows.Forms.Label();
			this.label1 = new System.Windows.Forms.Label();
			this.labMines = new System.Windows.Forms.Label();
			this.grid = new ppsGrid.Grid();
			this.SuspendLayout();
			// 
			// imgList
			// 
			this.imgList.ImageSize = new System.Drawing.Size(16, 16);
			this.imgList.TransparentColor = System.Drawing.SystemColors.Window;
			// 
			// labTime
			// 
			this.labTime.Font = new System.Drawing.Font("Tahoma", 15.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.labTime.Location = new System.Drawing.Point(162, 3);
			this.labTime.Name = "labTime";
			this.labTime.Size = new System.Drawing.Size(68, 18);
			this.labTime.TabIndex = 2;
			this.labTime.Text = "160";
			this.labTime.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			// 
			// btnSmilie
			// 
			this.btnSmilie.ImageAlign = System.Drawing.ContentAlignment.MiddleRight;
			this.btnSmilie.ImageList = this.imgList;
			this.btnSmilie.Location = new System.Drawing.Point(3, 3);
			this.btnSmilie.Name = "btnSmilie";
			this.btnSmilie.Size = new System.Drawing.Size(19, 17);
			this.btnSmilie.TabIndex = 1;
			this.btnSmilie.Click += new System.EventHandler(this.btnSmilie_Click);
			// 
			// tmeTime
			// 
			this.tmeTime.Tick += new System.EventHandler(this.Timer);
			// 
			// label2
			// 
			this.label2.Location = new System.Drawing.Point(142, 8);
			this.label2.Name = "label2";
			this.label2.Size = new System.Drawing.Size(21, 11);
			this.label2.TabIndex = 3;
			this.label2.Text = "Zeit";
			this.label2.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// label1
			// 
			this.label1.Location = new System.Drawing.Point(35, 8);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(27, 11);
			this.label1.TabIndex = 3;
			this.label1.Text = "Minen";
			this.label1.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// labMines
			// 
			this.labMines.Font = new System.Drawing.Font("Tahoma", 15.75F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.labMines.Location = new System.Drawing.Point(62, 3);
			this.labMines.Name = "labMines";
			this.labMines.Size = new System.Drawing.Size(55, 18);
			this.labMines.TabIndex = 2;
			this.labMines.Text = "160";
			this.labMines.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			// 
			// grid
			// 
			this.grid.BackColorApp = System.Drawing.SystemColors.Window;
			this.grid.Location = new System.Drawing.Point(3, 22);
			this.grid.Name = "grid";
			this.grid.Scrollbar = ppsGrid.eScrollbar.None;
			this.grid.SelectionType = ppsGrid.eSelectionType.None;
			this.grid.Size = new System.Drawing.Size(324, 447);
			this.grid.TabIndex = 0;
			this.grid.MouseDown += new System.Windows.Forms.MouseEventHandler(this.onMouseDown);
			this.grid.MouseUp += new System.Windows.Forms.MouseEventHandler(this.onMouseUp);
			// 
			// frmSweeper
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(329, 472);
			this.Controls.Add(this.labMines);
			this.Controls.Add(this.btnSmilie);
			this.Controls.Add(this.grid);
			this.Controls.Add(this.labTime);
			this.Controls.Add(this.label1);
			this.Controls.Add(this.label2);
			this.DockPadding.Top = 19;
			this.MaximizeBox = false;
			this.MinimizeBox = false;
			this.Name = "frmSweeper";
			this.SizeGripStyle = System.Windows.Forms.SizeGripStyle.Hide;
			this.StartPosition = System.Windows.Forms.FormStartPosition.Manual;
			this.Text = "GridSweeeeep...";
			this.ResumeLayout(false);
		}
		#endregion


	}
}

