using System;
using System.Collections;
using System.ComponentModel;
using System.Drawing;
using System.Diagnostics;

using System.Windows.Forms;
using ppsGrid;

namespace grdDemo.frm{
	public class frmTetris:System.Windows.Forms.Form{
		const int				CUBE_COUNT=7,WIDTH=16,HEIGHT=24;
		
		string[,]				vCubeList;
		string[]				vCurrCubeBits;

		Color[]					vCubeCols;
		int							vCurrCube,vCurrPosX,vCurrPosY;
		int							vTimeSpan=750;

		int							vCubesDone,vPoints,vLevel;

		private ppsGrid.Grid grid;
		private System.Windows.Forms.Button button1;
		private System.Windows.Forms.ImageList imgList;
		private System.Windows.Forms.Button button2;
		private System.Windows.Forms.Button button3;
		private System.Windows.Forms.Button button4;
		private System.Windows.Forms.ToolTip tipToolTip;
		private System.Windows.Forms.Button button5;
		private System.Windows.Forms.Timer tmeTime;
		private System.Windows.Forms.Label labLevel;
		private System.Windows.Forms.Label labPoints;
		private System.Windows.Forms.Label labPts;
		private System.Windows.Forms.Label labCubes;
		private System.ComponentModel.IContainer components = null;

		public frmTetris(){
			InitializeComponent();
			Size=new Size(334,498);
		}
		protected override void Dispose( bool disposing ){
			if(disposing)
				if (components != null) 
					components.Dispose();
			base.Dispose( disposing );
		}

		
		public void Init(){
			grid.AddCols(WIDTH+6);
			grid.AddRows(HEIGHT+1);

			foreach(GridCol col in grid.Cols)
				col.Width=16;
			foreach(GridRow row in grid.Rows)
				row.Height=16;

			grid.Rows[HEIGHT].Height=6;
			for(int x=0;x<3;x++){
				grid.Cols[x].Width=6;
				grid.Cols[3+WIDTH+x].Width=6;
			}
			for(int x=0;x<grid.Cols.Count;x++)		
				for(int y=0;y<grid.Rows.Count;y++)
					if(x<3 || x>WIDTH+2 || y==HEIGHT)											// ....rahmen links/rechts 3 spalten, boden 1 zeile
						grid[x,y].BackColorCell=Color.Black;
					else
						grid[x,y].BackColorCell=Color.White;

			vCubeList=new string[CUBE_COUNT,4];												// die steine (7 steine a' 4 zeilen)

			vCubeList[0,0]="    ";																		// der wrfel
			vCubeList[0,1]=" ## ";
			vCubeList[0,2]=" ## ";
			vCubeList[0,3]="    ";

			vCubeList[1,0]="    ";																		// treppe runter
			vCubeList[1,1]="##  ";
			vCubeList[1,2]=" ## ";
			vCubeList[1,3]="    ";

			vCubeList[2,0]="    ";																		// treppe rauf
			vCubeList[2,1]="  ##";
			vCubeList[2,2]=" ## ";
			vCubeList[2,3]="    ";

			vCubeList[3,0]="    ";																		// die brcke
			vCubeList[3,1]="####";
			vCubeList[3,2]="    ";
			vCubeList[3,3]="    ";

			vCubeList[4,0]="    ";																		// das dach
			vCubeList[4,1]=" #  ";
			vCubeList[4,2]="### ";
			vCubeList[4,3]="    ";

			vCubeList[5,0]="    ";																		// der baum
			vCubeList[5,1]="#  	";
			vCubeList[5,2]="### ";
			vCubeList[5,3]="    ";

			vCubeList[6,0]="    ";																		// die wurzel
			vCubeList[6,1]="###	";
			vCubeList[6,2]="#   ";
			vCubeList[6,3]="    ";

			vCubeCols=new Color[CUBE_COUNT]{
				Color.Red,Color.Orange,Color.Blue,Color.Silver,
				Color.Navy,Color.Green,Color.Lime};

			vCurrCubeBits=new string[4];																// aktueller stein
			vCurrPosY=-1;
			vLevel=vCubesDone=vPoints=0;

			tmeTime.Interval=vTimeSpan;
			tmeTime.Start();
		}

		private void tmeTime_Tick(object sender, System.EventArgs e) {
			int tmpPosX,tmpPosY;

			if(vCurrPosY==-1)																					// kein stein vorhanden ?
				GetNewCube();																						// ..erzeugen

			HideCube();																								// stein ausschalten
			tmpPosX=vCurrPosX;																				// position temporr speichern
			tmpPosY=vCurrPosY;
			CubeDown();																								// ein eine zeile tiefer

			if(CollisionCheck()==false){															// kollision prfen
				DrawCube();																							// stein zeichnen
			}
			else{																											// kollision !!
				vCurrPosX=tmpPosX;																				// ..alte position wiederherstellen
				vCurrPosY=tmpPosY;
				DrawCube();																							// ..stein zeichnen
				RemoveFullRow(vCurrPosY);																// ..volle zeilen prfen und entfernen
				if(vCurrPosY>1){																					// ..spiel weiter ?
					vCubesDone++;
					if(vCubesDone==25)
						NewLevel();
					GetNewCube();																					// ....neuer stein
				}
				else{																										// ..spielende
					tmeTime.Stop();
					MessageBox.Show(this,"The End");											// ..taraaa...
				}
			}
			DisplayState();
		}

		public void NewLevel(){
			for(int y=0;y<HEIGHT;y++)																	// alle...
				for(int x=0;x<WIDTH;x++)																// ..zellen..
					GetCell(y,x).BackColorCell=Color.White;								// ....lschen
			vLevel++;
			vPoints+=20;
			vCubesDone=0;
		}

		public void GetNewCube(){
			Random	rnd=new Random();

			vTimeSpan-=10;
			if(vTimeSpan<11)  vTimeSpan=11;														// neuen zeittakt einstellen
			tmeTime.Interval=vTimeSpan;

			vCurrCube=rnd.Next(CUBE_COUNT);																// stein auswhlen
			for(int y=0;y<4;y++)																			// daten..
				vCurrCubeBits[y]=vCubeList[vCurrCube,y];									// .. aktuellen stein kopieren

			vCurrPosY=0;																								// position ganz ob
			vCurrPosX=WIDTH/2;																					// ...und mittig
			vPoints+=3;
		}

		public void HideCube(){
			int	fldX,fldY;

			for(int y=0;y<4;y++){																			// alle zeilen
				for(int x=0;x<4;x++){																		// ..und spalten
					if(GetCubeBit(y,x)){																	// ....bit im stein gesetzt ?
						fldX=vCurrPosX+x;																		// ....zelle berechnen
						fldY=vCurrPosY+y;
						GetCell(fldY,fldX).BackColorCell=Color.White;				// ....wird hintergrundFarbe
					}
				}
			}
		}

		public void DrawCube(){
			GridCell	cell;
			int				fldX,fldY;

			for(int y=0;y<4;y++){																			// alle zeilen
				for(int x=0;x<4;x++){																		// ..und spalten
					if(GetCubeBit(y,x)){																	// ..bit im stein gesetzt ?
						fldX=vCurrPosX+x;																		// ..zelle berechnen
						fldY=vCurrPosY+y;
						cell=GetCell(fldY,fldX);														// ....zelle
						cell.BackColorCell=vCubeCols[vCurrCube];						// ....hintergrundfarbe ist steinfarbe
					}
				}
			}
		}

		public void CubeDown(){
			vCurrPosY++;																								// eine zeile... :-)
		}

		public bool CollisionCheck(){
			GridCell	cell;
			int				fldX,fldY;

			for(int y=3;y>=0;y--){																		// alle...
				for(int x=0;x<4;x++){																		// ..steindaten..
					if(GetCubeBit(y,x)){																	// ....bit gesetzt ?
						fldX=vCurrPosX+x;
						fldY=vCurrPosY+y;																		// ......position errechnen

						cell=GetCell(fldY,fldX);														// ......entspr. zelle berechnen
						if(cell.BackColorCell!=Color.White)									// ......keine "hintergrundFarbe" ?
							return(true);																			// ........Kollision !!!
					}
				}
			}
			return(false);																						// keine kollision
		}

		public bool GetCubeBit(int y,int x){
			return(vCurrCubeBits[y]==null
				?false
				:vCurrCubeBits[y].Substring(x,1)=="#");												// wenn #, dann true
		}

		public void RemoveFullRow(int row){
			GridCell	celld,cells;
			int				x,y,rw;

			for(rw=0;rw<4;rw++){																			// ab steinposition 4 zeilen
				if(row+rw<HEIGHT){																			// ..max. feldGre
					if(IsFullRow(row+rw)){																// ....zeile ist vollstndig ?
						vPoints+=10;																				// ......punkte :-)
						for(y=row+rw;y>1;y--){															// ......alle zeilen darber
							for(x=0;x<WIDTH;x++){															// ........alle zellen
								cells=GetCell(y-1,x);														// ........von zelle source darber
								celld=GetCell(y,x);															// ..........nach zelle ziel
								celld.BackColorCell=cells.BackColorCell;				// ..........kopieren
							}
						}
					}
				}
			}
		}

		public bool IsFullRow(int row){
			for(int x=0;x<WIDTH;x++)																	// alle zellen
				if(GetCell(row,x).BackColorCell==Color.White)						// ..frei ?
					return(false);																				// ....nicht voll (die zeile)
			return(true);																							// zeile ist vollstndig
		}

		public GridCell GetCell(int y,int x){
			GridCell	cell=grid.Cells[x+3,y];					
			return(cell);
		}

		public void LeftClick(object sender, System.EventArgs e){
			HideCube();																								// stein ausblenden
			vCurrPosX--;																							// ..und nach links
			if(CollisionCheck())																			// kollision ?
				vCurrPosX++;																						// ..wieder nach rechts
			DrawCube();																								// stein zeichnen
		}

		public void RightClick(object sender, System.EventArgs e){
			HideCube();																								// stein ausblenden
			vCurrPosX++;																							// ..und nach links
			if(CollisionCheck())																			// kollision ?
				vCurrPosX--;																						// ..wieder nach rechts
			DrawCube();																								// stein zeichnen
		}

		// stein rotieren
		public void RotaClick(object sender, System.EventArgs e){
			string[]	tmp=new string[4];
			string		s="",row;
			int				x,y;

			for(x=0;x<4;x++){																					// alle spalten..
				for(y=3,s="";y>=0;y--){																	// ..und zeilen..
					if(GetCubeBit(y,x))																		// ....bit holen (y <-> x)
						s+="#";																							// ......gesetzt ?
					else																									// ......nein..
						s+=" ";
				}
				tmp[x]=s;																								// temporr setzen
			}

			HideCube();																								// stein ausblenden
			for(y=0;y<4;y++){																					// alle zeilen
				row=vCurrCubeBits[y];																		// ..tauschen:
				vCurrCubeBits[y]=tmp[y];																	// ....gedrehte mit
				tmp[y]=row;																							// ....original
			}

			if(CollisionCheck())																			// kollision ??
				for(y=0;y<4;y++)																				// ..alle zeilen
					vCurrCubeBits[y]=tmp[y];																// ....wiederherstellen
			DrawCube();																								// stein zeichen
		}


		// spieler mchte pause machen bzw. weiter spielen
		public void PauseClick(object sender, System.EventArgs e){
			if(tmeTime.Enabled==false)																// pause gesetzt ?
				tmeTime.Start();																				// ..timer starten
			else																											// spiel an ?
				tmeTime.Stop();																					// ..timer starten
		}


		// stein schnell runter
		public void DownClick(object sender, System.EventArgs e){
			tmeTime.Interval=10;																			// zeitspanne sehr kurz
		}

		private void grid_KeyDown(object sender, System.Windows.Forms.KeyEventArgs e) {
			switch(e.KeyCode){
				case Keys.Left:																							// cursor left
					this.LeftClick(sender,e);
					break;
				case Keys.Right:																						// cursor right
					this.RightClick(sender,e);
					break;
				case Keys.Down:																							// cursor down
					DownClick(sender,e);
					break;
				case Keys.Up:																							// cursor up
				case Keys.Space:																						// space
					RotaClick(sender,e);
					break;
				case Keys.Escape:																						// taste escape
				case Keys.P:																								// Taste "P"
					PauseClick(sender,e);
					break;
			}
		}

		public void DisplayState(){
			if(tmeTime.Enabled==false)
				this.labPoints.Text="Pause";
			else
				this.labPoints.Text=vPoints.ToString();
			labLevel.Text=vLevel.ToString();
			labCubes.Text=vCubesDone.ToString()+":"+(25-vCubesDone).ToString();
		}

		#region Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.components = new System.ComponentModel.Container();
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(frmTetris));
			this.grid = new ppsGrid.Grid();
			this.button1 = new System.Windows.Forms.Button();
			this.imgList = new System.Windows.Forms.ImageList(this.components);
			this.button2 = new System.Windows.Forms.Button();
			this.button3 = new System.Windows.Forms.Button();
			this.button4 = new System.Windows.Forms.Button();
			this.tipToolTip = new System.Windows.Forms.ToolTip(this.components);
			this.button5 = new System.Windows.Forms.Button();
			this.tmeTime = new System.Windows.Forms.Timer(this.components);
			this.labLevel = new System.Windows.Forms.Label();
			this.labCubes = new System.Windows.Forms.Label();
			this.labPoints = new System.Windows.Forms.Label();
			this.labPts = new System.Windows.Forms.Label();
			this.SuspendLayout();
			// 
			// grid
			// 
			this.grid.Anchor = (((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right);
			this.grid.BackColorApp = System.Drawing.SystemColors.Window;
			this.grid.Location = new System.Drawing.Point(5, 8);
			this.grid.Name = "grid";
			this.grid.Scrollbar = ppsGrid.eScrollbar.None;
			this.grid.SelectionType = ppsGrid.eSelectionType.None;
			this.grid.Size = new System.Drawing.Size(242, 337);
			this.grid.TabIndex = 0;
			this.grid.KeyDown += new System.Windows.Forms.KeyEventHandler(this.grid_KeyDown);
			// 
			// button1
			// 
			this.button1.Anchor = (System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left);
			this.button1.Image = ((System.Drawing.Bitmap)(resources.GetObject("button1.Image")));
			this.button1.ImageAlign = System.Drawing.ContentAlignment.BottomCenter;
			this.button1.ImageIndex = 0;
			this.button1.ImageList = this.imgList;
			this.button1.Location = new System.Drawing.Point(34, 347);
			this.button1.Name = "button1";
			this.button1.Size = new System.Drawing.Size(18, 18);
			this.button1.TabIndex = 1;
			this.tipToolTip.SetToolTip(this.button1, "Links bewegen");
			this.button1.Click += new System.EventHandler(this.LeftClick);
			// 
			// imgList
			// 
			this.imgList.ColorDepth = System.Windows.Forms.ColorDepth.Depth8Bit;
			this.imgList.ImageSize = new System.Drawing.Size(16, 16);
			this.imgList.ImageStream = ((System.Windows.Forms.ImageListStreamer)(resources.GetObject("imgList.ImageStream")));
			this.imgList.TransparentColor = System.Drawing.SystemColors.Window;
			// 
			// button2
			// 
			this.button2.Anchor = (System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left);
			this.button2.Image = ((System.Drawing.Bitmap)(resources.GetObject("button2.Image")));
			this.button2.ImageAlign = System.Drawing.ContentAlignment.BottomCenter;
			this.button2.ImageIndex = 1;
			this.button2.ImageList = this.imgList;
			this.button2.Location = new System.Drawing.Point(56, 347);
			this.button2.Name = "button2";
			this.button2.Size = new System.Drawing.Size(17, 18);
			this.button2.TabIndex = 1;
			this.tipToolTip.SetToolTip(this.button2, "rechts bewegen");
			this.button2.Click += new System.EventHandler(this.RightClick);
			// 
			// button3
			// 
			this.button3.Anchor = (System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left);
			this.button3.Image = ((System.Drawing.Bitmap)(resources.GetObject("button3.Image")));
			this.button3.ImageAlign = System.Drawing.ContentAlignment.BottomCenter;
			this.button3.ImageIndex = 2;
			this.button3.ImageList = this.imgList;
			this.button3.Location = new System.Drawing.Point(43, 370);
			this.button3.Name = "button3";
			this.button3.Size = new System.Drawing.Size(23, 16);
			this.button3.TabIndex = 1;
			this.tipToolTip.SetToolTip(this.button3, "vorzeitig runter");
			this.button3.Click += new System.EventHandler(this.DownClick);
			// 
			// button4
			// 
			this.button4.Anchor = (System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left);
			this.button4.Image = ((System.Drawing.Bitmap)(resources.GetObject("button4.Image")));
			this.button4.ImageAlign = System.Drawing.ContentAlignment.BottomCenter;
			this.button4.ImageIndex = 4;
			this.button4.ImageList = this.imgList;
			this.button4.Location = new System.Drawing.Point(5, 347);
			this.button4.Name = "button4";
			this.button4.Size = new System.Drawing.Size(19, 20);
			this.button4.TabIndex = 1;
			this.tipToolTip.SetToolTip(this.button4, "Pause");
			this.button4.Click += new System.EventHandler(this.PauseClick);
			// 
			// button5
			// 
			this.button5.Anchor = (System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left);
			this.button5.Image = ((System.Drawing.Bitmap)(resources.GetObject("button5.Image")));
			this.button5.ImageAlign = System.Drawing.ContentAlignment.BottomCenter;
			this.button5.ImageIndex = 3;
			this.button5.ImageList = this.imgList;
			this.button5.Location = new System.Drawing.Point(86, 347);
			this.button5.Name = "button5";
			this.button5.Size = new System.Drawing.Size(21, 18);
			this.button5.TabIndex = 1;
			this.tipToolTip.SetToolTip(this.button5, "drehen");
			this.button5.Click += new System.EventHandler(this.RotaClick);
			// 
			// tmeTime
			// 
			this.tmeTime.Tick += new System.EventHandler(this.tmeTime_Tick);
			// 
			// labLevel
			// 
			this.labLevel.Anchor = (System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left);
			this.labLevel.Font = new System.Drawing.Font("Tahoma", 24F, (System.Drawing.FontStyle.Bold | System.Drawing.FontStyle.Italic), System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.labLevel.Location = new System.Drawing.Point(188, 356);
			this.labLevel.Name = "labLevel";
			this.labLevel.Size = new System.Drawing.Size(66, 32);
			this.labLevel.TabIndex = 2;
			this.labLevel.Text = "99";
			// 
			// labCubes
			// 
			this.labCubes.Anchor = (System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left);
			this.labCubes.BackColor = System.Drawing.Color.Transparent;
			this.labCubes.Location = new System.Drawing.Point(186, 348);
			this.labCubes.Name = "labCubes";
			this.labCubes.Size = new System.Drawing.Size(58, 11);
			this.labCubes.TabIndex = 2;
			this.labCubes.Text = "LEVEL";
			// 
			// labPoints
			// 
			this.labPoints.Anchor = (System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left);
			this.labPoints.Font = new System.Drawing.Font("Tahoma", 20.25F, (System.Drawing.FontStyle.Bold | System.Drawing.FontStyle.Italic), System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.labPoints.Location = new System.Drawing.Point(116, 360);
			this.labPoints.Name = "labPoints";
			this.labPoints.Size = new System.Drawing.Size(80, 35);
			this.labPoints.TabIndex = 2;
			this.labPoints.Text = "999";
			// 
			// labPts
			// 
			this.labPts.Anchor = (System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left);
			this.labPts.BackColor = System.Drawing.Color.Transparent;
			this.labPts.Location = new System.Drawing.Point(128, 348);
			this.labPts.Name = "labPts";
			this.labPts.Size = new System.Drawing.Size(64, 11);
			this.labPts.TabIndex = 2;
			this.labPts.Text = "POINTS";
			// 
			// frmTetris
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(6, 15);
			this.ClientSize = new System.Drawing.Size(249, 386);
			this.Controls.AddRange(new System.Windows.Forms.Control[] {
																																	this.labCubes,
																																	this.labPts,
																																	this.labLevel,
																																	this.button1,
																																	this.grid,
																																	this.button2,
																																	this.button3,
																																	this.button4,
																																	this.button5,
																																	this.labPoints});
			this.MaximizeBox = false;
			this.MinimizeBox = false;
			this.Name = "frmTetris";
			this.SizeGripStyle = System.Windows.Forms.SizeGripStyle.Hide;
			this.StartPosition = System.Windows.Forms.FormStartPosition.Manual;
			this.Text = "GridTris";
			this.ResumeLayout(false);

		}
		#endregion


	}
}

