using System;
using System.Windows.Forms;
using System.ComponentModel;
using	System.IO;																							//FileStream
using System.Drawing;


namespace grdDemo.frm{
	public class usrButtonVert:System.Windows.Forms.Button{
		#region Declaration
		private ToolTip	vToolTip;
		private bool		vClicked;
		#endregion
		#region Constructor
		public usrButtonVert():base(){
			vToolTip = new ToolTip();
			vToolTip.AutoPopDelay = 5000;
			vToolTip.InitialDelay = 300;
			vToolTip.ReshowDelay = 100;
			vToolTip.ShowAlways = true;
		}
		#endregion
		#region Destructor
		protected override void Dispose(bool disposing){
			if(vToolTip!=null){
				vToolTip.Dispose();
				vToolTip=null;
			}
			base.Dispose(disposing);
		}
		#endregion
		#region properties
		[Category("Behavior"),DefaultValue(true)]
		public virtual string ToolTip{
			get{return(vToolTip.GetToolTip(this));}
			set{vToolTip.SetToolTip(this,value);}
		}
		public override string Text{
			get{return(base.Text);}
			set{
				base.Text=value;
			}
		}
		#endregion

		protected override void OnMouseUp(MouseEventArgs mevent){
			vClicked=false;
			base.OnMouseUp(mevent);
		}
		protected override void OnMouseDown(MouseEventArgs mevent){
			vClicked=true;
			base.OnMouseDown(mevent);
		}
		protected override void OnKeyPress(KeyPressEventArgs e){
			if(e.KeyChar==' ')
				vClicked=true;
			base.OnKeyPress(e);
		}
		protected override void OnKeyUp(KeyEventArgs e){
			vClicked=false;
			base.OnKeyUp(e);
		}
		protected override void OnLeave(EventArgs e){
			vClicked=false;
			base.OnLeave(e);
		}

		protected override void OnPaint(PaintEventArgs e){
			if(Width>12 && Height>12){
				Rectangle			rct=this.DisplayRectangle;
				rct.Inflate(-6,-6);

				Bitmap				bm=new Bitmap(rct.Width,rct.Height);
				Graphics			gfx=Graphics.FromImage(bm);
				SolidBrush		brh=new SolidBrush(ForeColor);
				StringFormat	fmt=new StringFormat();

				base.OnPaint(e);

				switch(TextAlign){
					case ContentAlignment.TopLeft:
						fmt.LineAlignment = StringAlignment.Near;
						fmt.Alignment = StringAlignment.Near;
						break;
					case ContentAlignment.MiddleLeft:
						fmt.LineAlignment = StringAlignment.Center;
						fmt.Alignment = StringAlignment.Near;
						break;
					case ContentAlignment.BottomLeft:
						fmt.LineAlignment = StringAlignment.Far;
						fmt.Alignment = StringAlignment.Near;
						break;

					case ContentAlignment.TopCenter:
						fmt.LineAlignment = StringAlignment.Near;
						fmt.Alignment = StringAlignment.Center;
						break;
					case ContentAlignment.MiddleCenter:
						fmt.LineAlignment = StringAlignment.Center;
						fmt.Alignment = StringAlignment.Center;
						break;
					case ContentAlignment.BottomCenter:
						fmt.LineAlignment = StringAlignment.Far;
						fmt.Alignment = StringAlignment.Center;
						break;

					case ContentAlignment.TopRight:
						fmt.LineAlignment = StringAlignment.Near;
						fmt.Alignment = StringAlignment.Far;
						break;
					case ContentAlignment.MiddleRight:
						fmt.LineAlignment = StringAlignment.Center;
						fmt.Alignment = StringAlignment.Far;
						break;
					case ContentAlignment.BottomRight:
						fmt.LineAlignment = StringAlignment.Far;
						fmt.Alignment = StringAlignment.Far;
						break;
				}
			
				fmt.FormatFlags=StringFormatFlags.DirectionVertical | StringFormatFlags.DirectionRightToLeft;
				gfx.Clear(BackColor);

				if(Enabled==false){
					rct.Offset(1,1);
					brh.Color=SystemColors.Window;
					gfx.DrawString(Text,Font,brh,rct,fmt);
					rct.Offset(-1,-1);
					brh.Color=SystemColors.GrayText;
					gfx.DrawString(Text,Font,brh,rct,fmt);
				}
				else{
					Rectangle	r=new Rectangle(0,0,rct.Width,rct.Height);
					if(vClicked)	
						r.Offset(2,2);
					gfx.DrawString(Text,Font,brh,r,fmt);
				}

				e.Graphics.DrawImageUnscaled(bm,rct.Left,rct.Top);

				fmt.Dispose();
				brh.Dispose();
				gfx.Dispose();
				bm.Dispose();
			}
		}
	}
}

