using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Drawing.Text;
using System.Text;
using System.Diagnostics;
using System.IO;

using ppsGrid;

namespace grdDemo.frm{
	public class GridInGrid:Grid{
		private void InitializeComponent() {
			this.SuspendLayout();
			// 
			// GridInGrid
			// 
			this.BackColor = System.Drawing.SystemColors.Control;
			this.BackColorCell = System.Drawing.SystemColors.Control;
			this.BackColorFixed = System.Drawing.SystemColors.ActiveCaptionText;
			this.BackColorFixedGradient = System.Drawing.Color.Gray;
			this.BorderStyle = System.Windows.Forms.BorderStyle.None;
			this.ForeColorFixed = System.Drawing.Color.FromArgb(((System.Byte)(192)), ((System.Byte)(255)), ((System.Byte)(255)));
			this.Name = "GridInGrid";
			this.Scrollbar = ppsGrid.eScrollbar.Both;
			this.Size = new System.Drawing.Size(192, 184);
			this.ResumeLayout(false);

		}

		public GridInGrid(){
			Random	rnd=new Random();

			AddCols(4);
			AddRows(50);
			Rows[0].Fixed=Cols[0].Fixed=true;

			for(int c=0;c<Cols.Count;c++)
				for(int r=0;r<Rows.Count;r++)
					base[c,r].Value=frmCtrlControl.RandomString(rnd,20);

		}
		public GridInGrid myValue{
			get{return(this);}
			set{
				for(int c=0;c<Cols.Count;c++)
					for(int r=0;r<Rows.Count;r++)
						base[c,r].Value=value[c,r].Value;
			}
		}
		public override string	Text{
			get{
				string	s="";
				for(int r=0;r<Rows.Count;r++){
					for(int c=0;c<Cols.Count;c++)
						s+=base[c,r].Text;
					s+=System.Environment.NewLine;
				}
				return(s);
			}
			set{
				Debugger.Break();
			}
		}
	}
}